<?php
namespace Teknisa\CRM\Controller;

use Teknisa\CRM\Controller\TeknisaCrud;
use Zeedhi\Framework\DataSource\DataSet;
use Zeedhi\Framework\DTO\Response;
use Zeedhi\Framework\DTO\Request;
use Zeedhi\Framework\DTO\Request\Row;

class crm00050000InterlocutorRevendaController extends TeknisaCrud
{
    protected $dataSourceName = 'parcnegocio_relacionaparc_comunicaparc';
    protected $parameterBagColumns = array("P_NRORG", "P_PARCREVENDA");
    
    protected $interlocutorRevendaService;
    
    public function __construct ($crudService, $parameterBag, $interlocutorRevendaService){
        
        $this->interlocutorRevendaService   = $interlocutorRevendaService;
        
        parent::__construct($crudService, $parameterBag);
        
    }
    
    public function save(Request $request, Response $response) {
        parent::save($request, $response);
        
	    $columnsToReturn = $this->crudService->getColumnsToReturn();
	    
        $retorno = array();
        
        if (count($columnsToReturn) > 0){
            $retorno["NRPARCNEGOCIO"] = $columnsToReturn[0]["NRPARCNEGOCIO"];
        }
        
	    $response->addDataSet(new DataSet("columnsToReturn", $retorno));
    }
    
    public function insertPartnerCommunication(Row $row){
        
        $row = $row->getRow();
        
        $this->interlocutorRevendaService->callForInsertPartnerCommunication($row);

        
    }
    
    public function insertPartnerRelation(Row $row){
        
        $row = $row->getRow();
        
        $this->interlocutorRevendaService->callForInsertPartnerRelation($row);

        
    }
    
    public function insertPartnerParceria(Row $row){
        
        $row = $row->getRow();
        
        $this->interlocutorRevendaService->callForInsertPartnerParceria($row);

        
    }
    
    public function deletePartnerCommunication(Row $row){
       
        $row = $row->getRow();
        
        $this->interlocutorRevendaService->callForDeletePartnerCommunication($row);
        
    }
    
    public function updateRelationState(Row $row){
       
        $row = $row->getRow();
        
        $this->interlocutorRevendaService->callForUpdateRelationState($row);
        
    }
    
    public function inactivatePartner(Row $row){
        
        $row = $row->getRow();
        
        $this->interlocutorRevendaService->callForInactivatePartner($row);
         
    }
    
    public function deleteResaleRelation(Row $row){
        
        $row = $row->getRow();
        
        $this->interlocutorRevendaService->callForDeleteResaleRelation($row);
        
    }

}
?>