<?php
namespace Teknisa\CRM\Controller;

use Teknisa\CRM\Controller\TeknisaCrud;
use Zeedhi\Framework\DTO;
use Zeedhi\Framework\DataSource\DataSet;
use Doctrine\ORM\EntityManager;
use Zeedhi\Framework\DTO\Request\Row;
use Zeedhi\Framework\DTO\Response;
use Zeedhi\Framework\Util\Functions;

class crm20000EvolucaoCasoController extends TeknisaCrud
{
    protected $dataSourceName = 'evolcont_contato';

    protected $entityManager;
    protected $connection;
    protected $newCode;
    protected $environment;

    public function __construct ($crudService, $parameterBag, $entityManager, $newCode, $environment)
    {
        $this->entityManager = $entityManager;
        $this->newCode       = $newCode;
        $this->connection    = $entityManager->getConnection();
        $this->environment   = $environment;

        parent::__construct($crudService, $parameterBag);
    }

    public function save(DTO\Request $request, DTO\Response $response) {
        try {
            
            foreach($request->getDataSet()->getRows() as $row) {
                if (!\Zeedhi\Framework\Util\Functions::arrayKeyExists('DTULTATU', $row)) $row['DTULTATU'] = null;
                if (!\Zeedhi\Framework\Util\Functions::arrayKeyExists('IDATIVO', $row)) $row['IDATIVO'] = 'S';
                
                if ($row['__is_new'] && (!isset($row['NRSEQCONCLUSAO']))) {
                    if(empty($row['IDTPEVOLCONT'])) 
                        $row['IDTPEVOLCONT'] = 'P';
                    
                    if(empty($row['NRRELACIONAPARC'])) 
                        $row['NRRELACIONAPARC'] = '';
                    
                    if(empty($row['IDGERAFATURA'])) 
                        $row['IDGERAFATURA'] = 'NAO';
                    
                    if(empty($row['IDANEXOEVOLCONT'])) 
                        $row['IDANEXOEVOLCONT']= 'N';
                    
                    if(empty($row['IDSENEVOCONT'])) 
                        $row['IDSENEVOCONT']= 'S';
                    
                    if(empty($row['NRSEQFILACONTA'])) 
                        $row['NRSEQFILACONTA']= '';
                        
                    if(empty($row['NRTERMOPORTUNI'])) 
                        $row['NRTERMOPORTUNI']= '';
                        
                    $row["CDFILIAL"] = $this->environment->getCdFilial();
                    $row['NRSEQEVOLCONT'] = $this->newCode->getCodeByTableName("EVOLCONT", $row["NRORG"]);
                    $row['NRCONTATO'] = $row['NRSEQCONTATO'];
                    date_default_timezone_set('America/Sao_Paulo');
                    $row['DTINCLUSAO'] = date('d/m/y');
                    
                    $response->addDataSet(new DataSet("DADOS", array("NRSEQEVOLCONT" => $row["NRSEQEVOLCONT"], "DTINCLUSAO" => $row["DTINCLUSAO"])));
                } else {
                    date_default_timezone_set('America/Sao_Paulo');
                    $row['DTULTATU'] = date('d/m/y');
                    $response->addDataSet(new DataSet("DADOS", array("DTULTATU" => $row["DTULTATU"])));
                }
            }
            parent::save($request, $response);
        } catch(\Exception $e) {
            $response->setError(new \Zeedhi\Framework\DTO\Response\Error($e->getMessage(), $e->getCode()));
        }
    }
}