/*******************************************************************************/
/****                          DOC.FISCAIS/ESTOQUE                          ****/
/*******************************************************************************/
/*Criao:                                                                  ****/
/*   27/05/2015 - Jefferson Gouvea                                          ****/
/*******************************************************************************/

CREATE OR REPLACE TRIGGER LOG_ETIQUETAPRODOL
AFTER DELETE OR INSERT OR UPDATE ON ETIQUETAPRODOL FOR EACH ROW
DECLARE
  V_USUARIO        VARCHAR2(40);
  V_IDOPERAETIQ    VARCHAR2(1);
  V_CDCODBARRAETIQ VARCHAR2(50);
  V_DSOPERAETIQ    VARCHAR2(500);
  V_DSREMOTEADDR   VARCHAR2(15);
  V_DSREMOTEHOST   VARCHAR2(15);
  V_DSSERVERRDM    VARCHAR2(20);
  V_DSSERVMETHOD   VARCHAR2(30);
  V_DSREMOTEOPER   VARCHAR2(12);
  V_DTOPERAETIQ    DATE;
BEGIN
   V_IDOPERAETIQ := '0';
   V_DSOPERAETIQ := '';

   WEBTUNNING(V_DSREMOTEADDR,
              V_DSREMOTEHOST,
              V_DSSERVERRDM,
              V_DSSERVMETHOD,
              V_DSREMOTEOPER);

   IF DELETING THEN
      IF :OLD.QTETIQPROD IS NOT NULL THEN
         V_DSOPERAETIQ := V_DSOPERAETIQ || ' Qtde Etiq Prod=' || TO_CHAR(:OLD.QTETIQPROD);
      END IF;
      IF :OLD.VRPESOETIQ IS NOT NULL THEN
         V_DSOPERAETIQ := V_DSOPERAETIQ || ' Vr Peso Etiq=' || TO_CHAR(:OLD.VRPESOETIQ);
      END IF;
      IF :OLD.QTTOTALPRODETIQ IS NOT NULL THEN
         V_DSOPERAETIQ := V_DSOPERAETIQ || ' Qtde Total=' || TO_CHAR(:OLD.QTTOTALPRODETIQ);
      END IF;
      IF :OLD.IDSTATUSETIQ IS NOT NULL THEN
         V_DSOPERAETIQ := V_DSOPERAETIQ || ' Status=' || :OLD.IDSTATUSETIQ;
      END IF;
      IF :OLD.CDFILDEST IS NOT NULL THEN
         V_DSOPERAETIQ := V_DSOPERAETIQ || ' Fil Destino=' || :OLD.CDFILDEST;
      END IF;
      IF :OLD.CDFILLANC IS NOT NULL THEN
         V_DSOPERAETIQ := V_DSOPERAETIQ || ' Fil Lanc=' || :OLD.CDFILLANC;
      END IF;
      IF :OLD.NRPEDEXOL IS NOT NULL THEN
         V_DSOPERAETIQ := V_DSOPERAETIQ || ' Nr Ped=' || :OLD.NRPEDEXOL;
      END IF;
      IF :OLD.DSNOTAFISORIGET IS NOT NULL THEN
         V_DSOPERAETIQ := V_DSOPERAETIQ || ' Nota Origem=' || :OLD.DSNOTAFISORIGET;
      END IF;
      IF :OLD.DTPROGENPEOL IS NOT NULL THEN
         V_DSOPERAETIQ := V_DSOPERAETIQ || ' Dt Prog=' || TO_CHAR(:OLD.DTPROGENPEOL, 'DD/MM/YYYY');
      END IF;

      V_IDOPERAETIQ    := 'E';
      V_CDCODBARRAETIQ := :OLD.CDCODBARRAETIQ;

   ELSE
      IF UPDATING THEN
         IF (:OLD.QTETIQPROD      <> :NEW.QTETIQPROD)      OR
            (:OLD.VRPESOETIQ      <> :NEW.VRPESOETIQ)      OR
            (:OLD.QTTOTALPRODETIQ <> :NEW.QTTOTALPRODETIQ) OR
            (:OLD.IDSTATUSETIQ    <> :NEW.IDSTATUSETIQ)    OR
            (NVL(:OLD.CDFILDEST,'!')       <> NVL(:NEW.CDFILDEST,'!'))   OR
            (NVL(:OLD.CDFILLANC,'!')       <> NVL(:NEW.CDFILLANC,'!'))   OR
            (NVL(:OLD.NRPEDEXOL,'!')       <> NVL(:NEW.NRPEDEXOL,'!'))   OR
            (NVL(:OLD.DSNOTAFISORIGET,'!') <> NVL(:NEW.DSNOTAFISORIGET,'!')) OR
            (NVL(:OLD.DTPROGENPEOL,SYSDATE)<> NVL(:NEW.DTPROGENPEOL,SYSDATE)) THEN

            V_IDOPERAETIQ    := 'A';
            V_CDCODBARRAETIQ := :OLD.CDCODBARRAETIQ;

         END IF;
      ELSE
         V_IDOPERAETIQ    := 'I';
         V_CDCODBARRAETIQ := :NEW.CDCODBARRAETIQ;
      END IF;

      IF NVL(TO_CHAR(:NEW.QTETIQPROD), '!') <> NVL(TO_CHAR(:OLD.QTETIQPROD), '!') THEN
         V_DSOPERAETIQ := V_DSOPERAETIQ || ' Qtde Etiq Prod=' || TO_CHAR(:NEW.QTETIQPROD);
      END IF;

      IF NVL(TO_CHAR(:NEW.VRPESOETIQ), '!') <> NVL(TO_CHAR(:OLD.VRPESOETIQ), '!') THEN
         V_DSOPERAETIQ := V_DSOPERAETIQ || ' Vr Peso Etiq=' || TO_CHAR(:NEW.VRPESOETIQ);
      END IF;

      IF NVL(TO_CHAR(:NEW.QTTOTALPRODETIQ), '!') <> NVL(TO_CHAR(:OLD.QTTOTALPRODETIQ), '!') THEN
         V_DSOPERAETIQ := V_DSOPERAETIQ || ' Qtde Total=' || TO_CHAR(:NEW.QTTOTALPRODETIQ);
      END IF;

      IF NVL(:NEW.IDSTATUSETIQ, '!') <> NVL(:OLD.IDSTATUSETIQ, '!') THEN
         V_DSOPERAETIQ := V_DSOPERAETIQ || ' Status=' || :NEW.IDSTATUSETIQ;
      END IF;

      IF NVL(:NEW.CDFILDEST, '!') <> NVL(:OLD.CDFILDEST, '!') THEN
         V_DSOPERAETIQ := V_DSOPERAETIQ || ' Fil Destino=' || :NEW.CDFILDEST;
      END IF;

      IF NVL(:NEW.CDFILLANC, '!') <> NVL(:OLD.CDFILLANC, '!') THEN
         V_DSOPERAETIQ := V_DSOPERAETIQ || ' Fil Lanc=' || :NEW.CDFILLANC;
      END IF;

      IF NVL(:NEW.NRPEDEXOL, '!') <> NVL(:OLD.NRPEDEXOL, '!') THEN
         V_DSOPERAETIQ := V_DSOPERAETIQ || ' Nr Ped=' || :NEW.NRPEDEXOL;
      END IF;

      IF NVL(:NEW.DSNOTAFISORIGET, '!') <> NVL(:OLD.DSNOTAFISORIGET, '!') THEN
         V_DSOPERAETIQ := V_DSOPERAETIQ || ' Nota Origem=' || :NEW.DSNOTAFISORIGET;
      END IF;

      IF NVL(TO_CHAR(:NEW.DTPROGENPEOL, 'DD/MM/YYYY'), '!') <> NVL(TO_CHAR(:OLD.DTPROGENPEOL, 'DD/MM/YYYY'), '!') THEN
         V_DSOPERAETIQ := V_DSOPERAETIQ || ' Dt Prog=' || TO_CHAR(:NEW.DTPROGENPEOL, 'DD/MM/YYYY');
      END IF;
   END IF;

   IF V_IDOPERAETIQ <> '0' THEN
      NMUSUARIO(V_USUARIO);
      IF NOT V_USUARIO IS NULL THEN
         IF NOT V_DSOPERAETIQ IS NULL THEN
            V_DTOPERAETIQ := SYSDATE;

            INSERT INTO LOGOPERAETIQ
               (CDCODBARRAETIQ,
                DTOPERAETIQ,
                IDOPERAETIQ,
                DSOPERAETIQ,
                DSRDMUSUOPER,
                DSENDUSUOPER,
                DSNMUSUOPER,
                DSMETUSUOPER,
                CDORESPOPER)
            VALUES
               (V_CDCODBARRAETIQ,
                V_DTOPERAETIQ,
                V_IDOPERAETIQ,
                V_DSOPERAETIQ,
                V_DSREMOTEADDR,
                V_DSREMOTEHOST,
                V_DSSERVERRDM,
                V_DSSERVMETHOD,
                V_DSREMOTEOPER);
         END IF;
      END IF;
   END IF;
END;
/

-- VERSAO --
BEGIN ATUVEROBJ('LOG_ETIQUETAPRODOL','5.85.xxx'); END;
/
