CREATE OR REPLACE PROCEDURE PRECO_CUSTO_SERV(
   P_CDFILIAL   IN FILIAL.   CDFILIAL  %TYPE,
   P_CDCIA      IN COMPANHIA.CDCIA     %TYPE,
   P_CDMANCIA   IN MANUALCIA.CDMANCIA  %TYPE,
   P_CDSERVICO  IN PRODUTO.  CDPRODUTO %TYPE,
   P_FILIPROC   IN FILIAL.   CDFILIAL  %TYPE,
   P_DATACUSTO  IN DATE,
   P_TIPOCUSTO  IN NUMBER,
   P_TPCUSTOSM  IN CIAFILI.IDTIPOCUSTO%TYPE) /* P_TPCUSTOSM (TIPO DE CUSTO) DEVE SER "S" (SYSTEMICS) OU "M" (MARK-UP)*/
AS
   V_VRCUSTO      NUMBER;
   V_VRPARCCUSTO  NUMBER;
   V_VRPRECPORP   NUMBER;
   V_VRYIELD      NUMBER;
   V_VRPRECYIELD  NUMBER;
   V_VRCUSTOWRF   NUMBER;
   V_VRCUSTOPROD  NUMBER;
   V_VRPRECOSUB   NUMBER;

   V_VRCUSTOPRODM NUMBER;
   V_VRCUSTOEQUIM NUMBER;
   V_VRCUSRMPDELM NUMBER;
   V_VRMAODEOBRA  NUMBER;

   V_VRCUSTOPRODM_CALC NUMBER;
   V_VRCUSTOEQUIM_CALC NUMBER;
   V_VRCUSRMPDELM_CALC NUMBER;

   V_IDTIPOMARKUP PRODUTO.IDTIPOMARKUP%TYPE;
   V_VRCUSTOMANI  NUMBER;
   V_VRCUSTONMAN  NUMBER;
   V_VRCUSTOESPE  NUMBER;

   V_VRSERVICO    NUMBER;

   V_IDPRODCOMISS PRODUTO.IDPRODCOMISS%TYPE;

   V_CUSULCLIQGERT_SAP NUMBER;
   V_CUSULCLIQGERT_CAP NUMBER;
   V_CUSULCBRUGERT_SAP NUMBER;
   V_CUSULCBRUGERT_CAP NUMBER;
   V_CUSMEDLIQGERT_SAP NUMBER;
   V_CUSMEDLIQGERT_CAP NUMBER;
   V_CUSMEDBRUGERT_SAP NUMBER;
   V_CUSMEDBRUGERT_CAP NUMBER;

   V_CDSEQCUSRE CUSTOSEMA.CDSEQCUSSE%TYPE;

   V_SEQITEM NUMBER;

BEGIN
   V_CDSEQCUSRE := '0000000000';

   SELECT
      (VRCUSTOPROD/60) VRCUSTOPRODM,
      (VRCUSTOEQUI/60) VRCUSTOEQUIM,
      (VRCUSRMPDEL/60) VRCUSRMPDELM
   INTO V_VRCUSTOPRODM, V_VRCUSTOEQUIM, V_VRCUSRMPDELM
   FROM CIAFILI
   WHERE
      (CDFILIAL = P_CDFILIAL) AND
      (CDCIA    = P_CDCIA   );

   SELECT
      NVL(VRCUSTOMANI,0) VRCUSTOMANI,
      NVL(VRCUSTONMAN,0) VRCUSTONMAN,
      NVL(VRCUSTOESPE,0) VRCUSTOESPE
   INTO V_VRCUSTOMANI, V_VRCUSTONMAN, V_VRCUSTOESPE
   FROM CIAFILI
   WHERE
      (CDFILIAL = P_CDFILIAL) AND
      (CDCIA    = P_CDCIA   );

   FOR C_PRECUSTOSERV IN(SELECT
                            CDFILIAL, CDCIA, CDMANCIA, CDSERVICO, DTCUSTOSERV, CDSUBGRUPO
                         FROM
                            PRECUSTOSERV
                         WHERE
                            (CDFILIAL    = P_CDFILIAL ) AND
                            (CDCIA       = P_CDCIA    ) AND
                            (CDMANCIA    = P_CDMANCIA ) AND
                            (DTCUSTOSERV = P_DATACUSTO) AND
                            ((INSTR(P_CDSERVICO, CDSERVICO) > 0) OR P_CDSERVICO = 'T')) LOOP
      DELETE FROM PRECUSTOSERV
      WHERE
         (CDFILIAL    = C_PRECUSTOSERV.CDFILIAL   ) AND
         (CDCIA       = C_PRECUSTOSERV.CDCIA      ) AND
         (CDMANCIA    = C_PRECUSTOSERV.CDMANCIA   ) AND
         (IDTPMANUAL  = 'M'                       ) AND
         (CDSERVICO   = C_PRECUSTOSERV.CDSERVICO  ) AND
         (DTCUSTOSERV = C_PRECUSTOSERV.DTCUSTOSERV) AND
         (CDSUBGRUPO  = C_PRECUSTOSERV.CDSUBGRUPO );
   END LOOP;

   SELECT NVL(VRCUSTOWRF, 1)
   INTO   V_VRCUSTOWRF
   FROM   CIAFILI
   WHERE
      (CDFILIAL = P_CDFILIAL) AND
      (CDCIA    = P_CDCIA   );

   FOR C_SERVICO IN (SELECT
                        EP.CDFILIAL, EP.CDCIA, EP.CDMANCIA, EP.CDPRODUTO, EP.CDESPEPROD
                     FROM
                        ESPEPROD EP, PRODUTO PR
                     WHERE
                        (EP.CDPRODUTO = PR.CDPRODUTO) AND
                        (PR.IDPRODCOMISS = '1'      ) AND
                        (EP.CDFILIAL  = P_CDFILIAL  ) AND
                        (EP.CDCIA     = P_CDCIA     ) AND
                        (EP.CDMANCIA  = P_CDMANCIA  ) AND
                        (INSTR(P_CDSERVICO, EP.CDPRODUTO) >  0 OR (P_CDSERVICO = 'T'))) LOOP

      -- INSERE TODOS OS SUB-GRUPOS QUE CONTENHAM ALGUMA COMPOSIO

      FOR C_SUBGRUPO IN (SELECT  EP.CDFILIAL, EP.CDCIA, EP.CDMANCIA,
                                 CP.CDPRODUTOAUX AS CDSUBGRU, CP.CDESPEPROD AS CDESPESUB,
                                 CP.VRCUSTPRODMM, CP.VRCUSTEQUIMM, CP.VRCUSTRDELMM
                         FROM COMPPROD CP, ESPEPROD EP, PRODUTO PR
                         WHERE
                            (CP.CDPRODUTO    = C_SERVICO.CDPRODUTO ) AND
                            (CP.CDESPEPROD   = C_SERVICO.CDESPEPROD) AND
                            (CP.CDPRODUTOAUX = EP.CDPRODUTO        ) AND
                            (CP.CDESPPRODAUX = EP.CDESPEPROD       ) AND
                            (EP.IDTPMANUAL   = 'M'                 ) AND
                            (EP.CDFILIAL     = P_CDFILIAL          ) AND
                            (EP.CDCIA        = P_CDCIA             ) AND
                            (EP.CDMANCIA     = P_CDMANCIA          ) AND
                            (PR.IDPRODCOMISS = '2'                 ) AND
                            (CP.CDPRODINSUMO = PR.CDPRODUTO       )) LOOP


         V_VRCUSTOPRODM_CALC := (C_SUBGRUPO.VRCUSTPRODMM*V_VRCUSTOPRODM);
         V_VRCUSTOEQUIM_CALC := (C_SUBGRUPO.VRCUSTEQUIMM*V_VRCUSTOEQUIM);
         V_VRCUSRMPDELM_CALC := (C_SUBGRUPO.VRCUSTRDELMM*V_VRCUSRMPDELM);

         V_VRMAODEOBRA  := (V_VRCUSTOPRODM_CALC + V_VRCUSTOEQUIM_CALC + V_VRCUSRMPDELM_CALC);

         INSERT INTO PRECUSTOSERV
            (CDFILIAL, CDCIA, CDMANCIA, IDTPMANUAL, CDSERVICO, CDSUBGRUPO, DTCUSTOSERV,
             VRPRODUCAOMM, VREQUIPMM, VRRAMPDELMM, VRMAODEOBRA)
         VALUES
            (P_CDFILIAL, P_CDCIA, P_CDMANCIA, 'M', C_SERVICO.CDPRODUTO, C_SUBGRUPO.CDSUBGRU, P_DATACUSTO,
             C_SUBGRUPO.VRCUSTPRODMM, C_SUBGRUPO.VRCUSTEQUIMM, C_SUBGRUPO.VRCUSTRDELMM, V_VRMAODEOBRA);

         -- VARIAVEL DEVE RECEBER ZERO TODA VEZ QUE TROCAR O SUB-GRUPO
         V_VRPRECOSUB := 0;

         FOR C_PRODREC IN (SELECT
                              EP.CDFILIAL, EP.CDCIA, EP.CDMANCIA, EP.CDESPEPROD,
                              CP.CDPRODUTO AS CDSUBGRU, CP.CDPRODINSUMO AS CDPRODUTO,
                              CP.CDPRODUTOAUX AS CDSERVICO, CP.QTINSUMO, PR.IDPRODCOMISS,
                              NVL(((100-VRPEFATOCORR)/100), 1) , NVL(IDTIPOMARKUP,'N') IDTIPOMARKUP
                           FROM
                              COMPPROD CP, ESPEPROD EP, PRODUTO PR
                           WHERE
                              (EP.IDTPMANUAL   = 'M'                 ) AND
                              (EP.CDFILIAL     = P_CDFILIAL          ) AND
                              (EP.CDCIA        = P_CDCIA             ) AND
                              (EP.CDMANCIA     = P_CDMANCIA          ) AND
                              (EP.CDPRODUTO    = C_SERVICO.CDPRODUTO ) AND
                              (CP.CDPRODUTO    = C_SUBGRUPO.CDSUBGRU ) AND
                              (CP.CDPRODUTOAUX = EP.CDPRODUTO        ) AND
                              (CP.CDESPPRODAUX = EP.CDESPEPROD       ) AND
                              (CP.CDPRODINSUMO = PR.CDPRODUTO        )) LOOP
            IF (C_PRODREC.IDPRODCOMISS IS NULL) THEN
               BEGIN
                   SELECT DECODE(P_TIPOCUSTO, 0, MAX(VRULTCLIQAP),
                          DECODE(P_TIPOCUSTO, 1, MAX(VRULTCBRUAP),
                          DECODE(P_TIPOCUSTO, 2, MAX(VRMEDLIQAP ),
                          MAX(VRMEDBRUAP))))
                   INTO   V_VRCUSTO
                   FROM   PRODUTOAP
                   WHERE (CDFILIAL   = P_CDFILIAL         ) AND
                         (CDPRODUTO  = C_PRODREC.CDPRODUTO) AND
                         (DTCUSTOAP  = (SELECT MAX(DTCUSTOAP)
                                        FROM PRODUTOAP
                                        WHERE (CDFILIAL   = P_CDFILIAL         ) AND
                                              (CDPRODUTO  = C_PRODREC.CDPRODUTO) AND
                                              (DTCUSTOAP <= P_DATACUSTO        )));
               EXCEPTION
                  WHEN NO_DATA_FOUND THEN
                     V_VRCUSTO := NULL;
               END;
            END IF;

            IF (C_PRODREC.IDPRODCOMISS = '3') THEN -- YIELD E PRECO DE COMPRA DAS RECEITAS
               -- YIELD
               V_VRYIELD := 1;

               CUSTOREC(V_CDSEQCUSRE, '', V_SEQITEM, 'G', 'N', 'N', P_FILIPROC, '', '', '', '',
                        C_PRODREC.CDPRODUTO, '', 1.0,  P_DATACUSTO, '', V_CUSULCLIQGERT_SAP,
                        V_CUSULCLIQGERT_CAP, V_CUSULCBRUGERT_SAP, V_CUSULCBRUGERT_CAP, V_CUSMEDLIQGERT_SAP,
                        V_CUSMEDLIQGERT_CAP, V_CUSMEDBRUGERT_SAP, V_CUSMEDBRUGERT_CAP);

               IF (P_TIPOCUSTO = 0) THEN
                  V_VRCUSTO := V_CUSULCLIQGERT_CAP;
               ELSE IF (P_TIPOCUSTO = 1) THEN
                        V_VRCUSTO := V_CUSULCBRUGERT_CAP;
                    ELSE IF (P_TIPOCUSTO = 2) THEN
                             V_VRCUSTO := V_CUSMEDLIQGERT_CAP;
                         ELSE
                             V_VRCUSTO := V_CUSMEDBRUGERT_CAP;
                         END IF;
                    END IF;
               END IF;
            END IF;

            V_VRPRECPORP  := ROUND((NVL(ROUND(V_VRCUSTO,2),1) * NVL(C_PRODREC.QTINSUMO, 1)),2);
            V_VRPRECYIELD := ROUND((ROUND(V_VRPRECPORP,2)/ROUND(V_VRYIELD,2)),2);

            IF (P_TPCUSTOSM = 'S') THEN
               IF V_VRCUSTOWRF > 0 THEN
                  V_VRCUSTOPROD := ROUND((V_VRPRECYIELD/V_VRCUSTOWRF),2);
               ELSE
                  V_VRCUSTOPROD := ROUND((V_VRPRECYIELD/1),2);
               END IF;
            ELSE
               SELECT DISTINCT DECODE(V_IDTIPOMARKUP,'M',(V_VRPRECYIELD*V_VRCUSTOMANI),
                               DECODE(V_IDTIPOMARKUP,'N',(V_VRPRECYIELD*V_VRCUSTONMAN),
                               DECODE(V_IDTIPOMARKUP,'E',(V_VRPRECYIELD*V_VRCUSTOESPE)))) VRCUSTOPROD
               INTO V_VRCUSTOPROD
               FROM CIAFILI;
            END IF;

            INSERT INTO ITCUSTOSERV
               (CDFILIAL, CDCIA, CDMANCIA, IDTPMANUAL, CDSERVICO, DTCUSTOSERV, CDSUBGRUPO, CDPRODUTO,
                VRPRECOCOMP, VRPRECOPRO, VRPRECPRPRO, VRYIELD, VRPRECYIELD, VRPRECOWRF, VRPRECOPROD)
            VALUES
               (P_CDFILIAL, P_CDCIA, P_CDMANCIA, 'M', C_PRODREC.CDSERVICO, P_DATACUSTO, C_PRODREC.CDSUBGRU, C_PRODREC.CDPRODUTO,
                V_VRCUSTO, C_PRODREC.QTINSUMO, V_VRPRECPORP, V_VRYIELD, V_VRPRECYIELD, V_VRCUSTOWRF, V_VRCUSTOPROD);

         END LOOP;

         BEGIN
            SELECT SUM(VRPRECOPROD) VRPRECOPROD
            INTO   V_VRPRECOSUB
            FROM   ITCUSTOSERV
            WHERE
               (CDFILIAL    = P_CDFILIAL          ) AND
               (CDCIA       = P_CDCIA             ) AND
               (CDMANCIA    = P_CDMANCIA          ) AND
               (IDTPMANUAL  = 'M'                 ) AND
               (CDSERVICO   = C_SERVICO.CDPRODUTO ) AND
               (DTCUSTOSERV = P_DATACUSTO         ) AND
               (CDSUBGRUPO  = C_SUBGRUPO.CDSUBGRU );
         EXCEPTION
            WHEN NO_DATA_FOUND THEN
               V_VRPRECOSUB := NULL;

         END;

         IF (P_TPCUSTOSM = 'S') THEN
            UPDATE PRECUSTOSERV
            SET    VRPRECOSUB  = (ROUND(V_VRMAODEOBRA,2) + ROUND(NVL(V_VRPRECOSUB,0),2))
            WHERE
               (CDFILIAL    = P_CDFILIAL          ) AND
               (CDCIA       = P_CDCIA             ) AND
               (CDMANCIA    = P_CDMANCIA          ) AND
               (IDTPMANUAL  = 'M'                 ) AND
               (CDSERVICO   = C_SERVICO.CDPRODUTO ) AND
               (DTCUSTOSERV = P_DATACUSTO         ) AND
               (CDSUBGRUPO  = C_SUBGRUPO.CDSUBGRU );

         ELSE
            UPDATE PRECUSTOSERV
            SET    VRPRECOSUB  = ROUND(V_VRPRECOSUB,2)
            WHERE
               (CDFILIAL    = P_CDFILIAL          ) AND
               (CDCIA       = P_CDCIA             ) AND
               (CDMANCIA    = P_CDMANCIA          ) AND
               (IDTPMANUAL  = 'M'                 ) AND
               (CDSERVICO   = C_SERVICO.CDPRODUTO ) AND
               (DTCUSTOSERV = P_DATACUSTO         ) AND
               (CDSUBGRUPO  = C_SUBGRUPO.CDSUBGRU );
         END IF;
      END LOOP;

      BEGIN
         SELECT SUM(VRPRECOSUB)
         INTO   V_VRSERVICO
         FROM   PRECUSTOSERV
         WHERE
            (CDFILIAL    = P_CDFILIAL         ) AND
            (CDCIA       = P_CDCIA            ) AND
            (CDMANCIA    = P_CDMANCIA         ) AND
            (IDTPMANUAL  = 'M'                ) AND
            (CDSERVICO   = C_SERVICO.CDPRODUTO) AND
            (DTCUSTOSERV = P_DATACUSTO        );
      EXCEPTION
         WHEN NO_DATA_FOUND THEN
            V_VRSERVICO := NULL;
      END;

      UPDATE PRECUSTOSERV
      SET    VRPRECOSERV = V_VRSERVICO
      WHERE
         (CDFILIAL    = P_CDFILIAL         ) AND
         (CDCIA       = P_CDCIA            ) AND
         (CDMANCIA    = P_CDMANCIA         ) AND
         (IDTPMANUAL  = 'M'                ) AND
         (CDSERVICO   = C_SERVICO.CDPRODUTO) AND
         (DTCUSTOSERV = P_DATACUSTO        );
   END LOOP;
END;
/

-- VERSAO --
BEGIN ATUVEROBJ('PRECO_CUSTO_SERV','5.01.009'); END;
/

