create or replace PROCEDURE IMPORTA_INVE_ESTOQUE_SAGA
IS
   /* INT_MOVTRSESQ */
   V_IDCSEQ         INTEGER;
   V_CDFILIAL       VARCHAR2(4);
   V_CDOPERADORSAGA VARCHAR2(12);
   V_DATGRCTRSESQ   DATE; 
   V_CODMER         VARCHAR2(20);
   V_CODMERERRO     VARCHAR2(20);
   V_VALQTD         FLOAT;
   V_DTMOVI         VARCHAR2(10);
   /*  */
   V_PRODUTO    VARCHAR2(10);
   V_FILIMOVI   VARCHAR2(4);
   V_CDALMOX    VARCHAR2(6);
   V_CDLOCEST   VARCHAR2(6);
   V_CDTPCUST   VARCHAR2(2);
   V_ORDIMPL    VARCHAR2(1);
   
   V_NOVAFILI   BOOLEAN;
   V_NOVOREGE   BOOLEAN;
   V_DATAINI    VARCHAR2(10);
   V_NRLANCESTQ VARCHAR2(20);
   V_CONTADOR   INTEGER;
   
   V_QTDEESTO   FLOAT;
   V_VALRESTO   FLOAT;
   V_VALRBRUT   FLOAT;
   V_VRTOTLAN   FLOAT;
   
   V_CDFILIMOVI VARCHAR2(4);
   V_ERRO       VARCHAR2(500);
   V_NMPRODUTO  VARCHAR2(80);
   V_BOATUALIZA BOOLEAN;
   V_VRFATORSKU FLOAT;
   V_IDPRODMENSU VARCHAR2(1);
   V_DTPOSIESTQ DATE;

   CURSOR C_INT_MOVTRSESQ IS
      SELECT E.IDCEXPESQSNT, F.CDFILIAL/*F.CDFILCENTCMP*/, P.CDOPERADORSAGA, TO_DATE(E.DATLAN) AS DATGRCTRSESQ, E.CODMER, E.QTDMER,
             TO_CHAR(TRUNC(E.DATLAN), 'DD/MM/YYYY') AS DTMOVI, NVL(P.CDALMOXARIFE, ' ') CDALMOXARIFE, NVL(P.CDLOCALESTOQ, ' ') CDLOCALESTOQ,  
             NVL(P.CDTIPCUSTEST,'03') CDTIPCUSTEST, P.IDORDAJUINVE
        FROM PARAMFILIAL P, INT_EXPESQSNT E, FILIAL F
       WHERE P.CDFILIALSAGA IS NOT NULL
         AND P.CDOPERADORSAGA IS NOT NULL
         AND E.CODSTE   = P.CDFILIALSAGA
         AND P.CDFILIAL = F.CDFILIAL
         AND E.FLAPRC   = '0'
       ORDER BY P.CDFILIAL, E.DATLAN, E.CODMER;
BEGIN
   V_DATAINI    := ' ';
   V_CDFILIMOVI := ' ';
   V_NOVOREGE   := FALSE;
   V_BOATUALIZA := FALSE;
   OPEN C_INT_MOVTRSESQ;
   LOOP
      FETCH C_INT_MOVTRSESQ INTO V_IDCSEQ, V_CDFILIAL, V_CDOPERADORSAGA, V_DATGRCTRSESQ, V_CODMER, V_VALQTD,
                                 V_DTMOVI, V_CDALMOX, V_CDLOCEST, 
                                 V_CDTPCUST, V_ORDIMPL;
      IF ((V_DATAINI <> V_DTMOVI) OR (V_CDFILIMOVI <> V_CDFILIAL)) THEN
         V_NOVOREGE := TRUE;
      END IF;
      
      IF ((C_INT_MOVTRSESQ%NOTFOUND) OR (V_NOVOREGE)) THEN
         IF (V_BOATUALIZA) THEN
            ATUALIZA_ESTOQUE(V_CDFILIMOVI, V_DATAINI, V_DATAINI, V_CDFILIMOVI, V_NRLANCESTQ);
            COMMIT;
         END IF;
         V_BOATUALIZA := TRUE;
      END IF;
      
      EXIT WHEN C_INT_MOVTRSESQ%NOTFOUND;
      
      BEGIN
         SELECT P.CDPRODESTO, P.NMPRODUTO
           INTO V_PRODUTO, V_NMPRODUTO
           FROM PRODUTO P
          WHERE CDARVPROD = V_CODMER;
      EXCEPTION
         WHEN NO_DATA_FOUND THEN
            V_PRODUTO    := NULL;
            V_BOATUALIZA := FALSE;
            V_CODMERERRO := V_CODMER;
      END;
      
      IF (V_PRODUTO IS NOT NULL) THEN
         --IF (V_BOATUALIZA) THEN
            BEGIN
               IF (V_NOVOREGE) THEN
                  V_CDFILIMOVI := V_CDFILIAL;
                  V_DATAINI    := V_DTMOVI;
                  V_CONTADOR := 1;
                  NOVO_CODIGO_SC('LANCTOEST'||V_CDFILIMOVI, V_NRLANCESTQ);
                  V_NRLANCESTQ := SUBSTR(V_NRLANCESTQ, -10);
                  
                  CASE NVL(TRIM(V_ORDIMPL), 'P')
                      WHEN ('P') THEN V_ORDIMPL := 'O';
                      ELSE V_ORDIMPL := 'U';
                   END CASE;
                  
                  INSERT INTO LANCTOESTOQ
                    (CDFILIAL, NRLANCESTQ, IDTPLANCTO, DTLANCESTQ, DSLANCESTQ, CDOPERADOR, CDFILIMOVI,
                     CDALMOXARIFE, CDLOCALESTOQ)
                  VALUES
                    (V_CDFILIMOVI, V_NRLANCESTQ, '1', V_DATAINI, 'Inventrio de estoque SAGA', V_CDOPERADORSAGA, V_CDFILIMOVI, 
                     V_CDALMOX, V_CDLOCEST);
                  
                  V_NOVOREGE := FALSE;
               END IF;

               BEGIN
                  SELECT MAX(VRESTOQDIA/QTESTOQDIA), MAX(DTPOSIESTQ)
                    INTO V_VALRESTO, V_DTPOSIESTQ
                    FROM POSESTDIA P
                   WHERE P.CDFILIAL  = V_CDFILIMOVI
                     AND P.CDPRODUTO = V_PRODUTO
                     AND P.QTESTOQDIA <> 0
                     AND P.DTPOSIESTQ <= (SELECT MAX(DTPOSIESTQ)
                                           FROM POSESTDIA
                                          WHERE CDFILIAL = P.CDFILIAL
                                            AND CDALMOXARIFE = P.CDALMOXARIFE
                                            AND CDLOCALESTOQ = P.CDLOCALESTOQ
                                            AND NRLOTEESTQ = P.NRLOTEESTQ
                                            AND NRSUBLOTE = P.NRSUBLOTE
                                            AND CDPRODUTO = P.CDPRODUTO
                                            AND DTPOSIESTQ <= TO_DATE(V_DATAINI)+1);
                  
               EXCEPTION
                  WHEN NO_DATA_FOUND THEN
                     V_VALRESTO := 0;
               END;
                
               --POSICAO_ESTOQUE(V_CDFILIMOVI, V_PRODUTO, TO_DATE(V_DATAINI), V_QTDEESTO, V_VALRESTO, V_VALRBRUT);
               IF V_VALRESTO <> 0.0 THEN
                  IF (V_BOATUALIZA) THEN
                  --V_BOATUALIZA := TRUE;
                      BEGIN
                         SELECT P.VRFATOCONV, NVL(C.IDPRODMENSU, 'N') IDPRODMENSU
                           INTO V_VRFATORSKU, V_IDPRODMENSU
                           FROM PRODUTO P, CARACPRODSAGA C
                          WHERE P.CDPRODESTO = V_PRODUTO
                            AND P.CDPRODUTO  = C.CDPRODUTO
                            AND C.IDUNIDPADRSAGA = 'S';
                      EXCEPTION
                         WHEN OTHERS THEN
                            ROLLBACK;
                            V_VRFATORSKU := 0;
                            V_BOATUALIZA := FALSE;
                            V_ERRO := 'Produto '||V_CODMER||' no possui unidade de medida padro cadastrado.';
                            UPDATE INT_EXPESQSNT
                               SET FLAPRC = '2', 
                                   DATULTPRC = SYSDATE,
                                   DSCERR = SUBSTR(V_ERRO, 1, 300)
                             WHERE IDCEXPESQSNT = V_IDCSEQ;
                             
                             COMMIT;
                      END;
                      
                      IF (V_VRFATORSKU > 0) THEN
                         IF V_IDPRODMENSU = 'N' THEN
                            V_VALQTD := (V_VALQTD * V_VRFATORSKU);
                          ELSE
                             V_VALQTD := V_VALQTD;
                          END IF;
                         
                         V_VRTOTLAN := (V_VALRESTO * V_VALQTD);
                         
                         INSERT INTO ITLANCTOEST
                            (CDFILIAL, NRLANCESTQ, NRSEQUITEM, CDPRODUTO, QTLANCTOEST, QTTOTLANCTO,
                             CDPRODMOVI, CDFILIMOVI, CDALMOXARIFE, CDLOCALESTOQ, NRLOTEESTQ, NRSUBLOTE, 
                             IDTIPOMOVI, IDEVOLESTOQ, IDORDEMCLC, DTLANCMOVI, VRUNILANCTO,
                             VRTOTLANCTO, VRLANCTOEST)
                         VALUES
                            (V_CDFILIMOVI, V_NRLANCESTQ, V_CONTADOR, V_PRODUTO, V_VALQTD, V_VALQTD,
                             V_PRODUTO, V_CDFILIMOVI, V_CDALMOX, V_CDLOCEST, ' ', ' ', 
                             '1', 'S', V_ORDIMPL, V_DATAINI, V_VALRESTO,
                             V_VRTOTLAN, V_VRTOTLAN);
                         
                         V_CONTADOR := V_CONTADOR + 1;
                         
                         UPDATE INT_EXPESQSNT
                            SET FLAPRC = '1', 
                                DATULTPRC = SYSDATE
                          WHERE IDCEXPESQSNT = V_IDCSEQ;
                      END IF;
                   ELSE
                      ROLLBACK;
                      V_ERRO := 'Todos tens inventariados para a filial/perodo informado no sero lanados';
                      UPDATE INT_EXPESQSNT
                         SET FLAPRC = '2', 
                             DSCERR = SUBSTR(V_ERRO, 1, 300),
                             DATULTPRC = SYSDATE
                       WHERE IDCEXPESQSNT = V_IDCSEQ;
                       COMMIT;
                   END IF;
               ELSE
                  ROLLBACK;
                  V_BOATUALIZA := FALSE;
                  V_ERRO := 'Produto '||V_CODMER||' - '||V_NMPRODUTO||' sem custo no estoque';
                  UPDATE INT_EXPESQSNT
                     SET FLAPRC = '2', 
                         DATULTPRC = SYSDATE,
                         DSCERR = SUBSTR(V_ERRO, 1, 300)
                   WHERE IDCEXPESQSNT = V_IDCSEQ;
                   COMMIT;
               END IF;
            EXCEPTION
               WHEN OTHERS THEN
                  V_BOATUALIZA := FALSE;
                  V_ERRO := SQLERRM(SQLERRM);
                  ROLLBACK;
                  UPDATE INT_EXPESQSNT
                     SET FLAPRC = '2', 
                         DSCERR = SUBSTR(V_ERRO, 1, 300),
                         DATULTPRC = SYSDATE
                   WHERE IDCEXPESQSNT = V_IDCSEQ;
                  COMMIT; 
            END;
         /*ELSE
            ROLLBACK;
            V_ERRO := 'Todos tens inventariados para a filial/perodo informado no sero lanados';
            UPDATE INT_EXPESQSNT
               SET FLAPRC = '2', 
                   DSCERR = SUBSTR(V_ERRO, 1, 300),
                   DATULTPRC = SYSDATE
             WHERE IDCEXPESQSNT = V_IDCSEQ;
             COMMIT;
         END IF;*/
      ELSE
         ROLLBACK;
         V_BOATUALIZA := FALSE;
         V_ERRO       := 'O item '||V_CODMERERRO|| ' no foi encontrado no sistema Teknisa';
         UPDATE INT_EXPESQSNT
            SET FLAPRC = '2', 
                DSCERR = SUBSTR(V_ERRO, 1, 300),
                DATULTPRC = SYSDATE
          WHERE IDCEXPESQSNT = V_IDCSEQ;
          COMMIT;
      END IF;
   END LOOP;
   
   CLOSE C_INT_MOVTRSESQ;
   COMMIT;
EXCEPTION
   WHEN OTHERS THEN
      ROLLBACK;
      V_ERRO := SUBSTR(SQLERRM(SQLERRM), 1, 300);
      UPDATE INT_EXPESQSNT
         SET FLAPRC = '2', 
             DSCERR = V_ERRO, 
             DATULTPRC = SYSDATE
       WHERE IDCEXPESQSNT = V_IDCSEQ;
      COMMIT;
      CLOSE C_INT_MOVTRSESQ;
END;
/

-- VERSAO --
BEGIN ATUVEROBJ('IMPORTA_INVE_ESTOQUE_SAGA','6.05.XXX'); END;
/