function Crm_31000_Agenda_de_Tarefas_Controller(ScreenService, templateManager, Utilities, restEngine, fileRepository, localStorageEngine, CRM_Utilities, General, Messages, ZHPromise, ABEvolucaoController, evolutionTabController) { // zhFilterPreferences removido
    var self = this;
    var backupTipo = '';
    
    self.setFiltrosIniciais = function(widget) {

        var filter = {};
        filter.name = "STATUS_PRINCIPAL";
        filter.operator = "IN";
        filter.value = ['ATRASADA', 'HOJE'];
        widget.dataSourceFilter.push(filter);
        widget.reload();

    };

    self.clearInitialFilters = function(widget) {
        widget.dataSourceFilter.forEach(function(filter, index, dataSourceFilter) {
            if (filter.name === "STATUS_PRINCIPAL") {
                dataSourceFilter.splice(index, 1);
            }
        });
    };

    self.setFilterOperator = function(fieldOperator) {
        var loggedOperatorInfos = CRM_Utilities.getLoggedOperatorInfos();

        fieldOperator.dataSourceFilter.forEach(function(filter) {
            if (filter.name === "P_NRORG") {
                filter.value = loggedOperatorInfos.NRORG;
            }
            if (filter.name === "P_NRPARCNEGOCIO") {
                filter.value = loggedOperatorInfos.NRPARCNEGOCIO;
            }
        });

    };

    self.taskSchedule = function(widget) {
        General.widgetNewRow(widget);
        self.activateField(widget, "DESCRICAO", "TIPO", "NMINTERLOCUTOR");

        var loggedOperatorInfos = CRM_Utilities.getLoggedOperatorInfos();

        widget.currentRow.IDATIVO = 'S';

        widget.currentRow.NMOPERREAL = loggedOperatorInfos.NMOPERADOR;
        widget.currentRow.CDOPERREAL = loggedOperatorInfos.CDOPERADOR;
        // widget.currentRow.NRPRIORFILACONT = 2;
        widget.currentRow.DTPLANFILACONTA = (widget.currentRow.DTPLANFILACONTA) ? widget.currentRow.DTPLANFILACONTA : moment(new Date()).format('DD/MM/YYYY HH:mm');

        widget.currentRow.NRCONTATO = null;
        widget.currentRow.NRSEQCONTATO = null;
        widget.currentRow.DSEMAILTAREFA = '';
        widget.currentRow.DSFILACONTATO = null;
        widget.currentRow.NRCOMUNICAPARC = null;
        widget.currentRow.DSDETEFILACONTA = '';
        widget.currentRow.DTVENCFILACONTA = null;
        widget.currentRow.NRRELACIONAPARC = null;
        widget.currentRow.DTREALFILACONTA = null;
        widget.currentRow.DSTELEFONETAREFA = '';
        widget.currentRow.NRSEQCLASSIFICATAREFA = null;
        widget.currentRow.CRM_NRORGTRAB = getLocalVar('CRM_NRORGTRABALHO');
        widget.currentRow.NMORGTRAB = getLocalVar('NMORGTRAB');


        this.configureBlockedFieldsToEdit(widget, false);
        this.setDescricaoDataSourceFilter(widget);
        this.setDescricaoReadOnly(widget);

    };

    /**
     * Habilita o ambiente de edição para a tarefa
     * selecionada.
     * 
     * @param {object} widget widget da agenda de 
     * tarefas.
     */
    this.editTask = function(widget) {
        var nrParcNegocio = widget.currentRow.NRPARCNEGOCIO;
        var tipoParc = widget.currentRow.TIPOPARCPRINC;
        
        if(tipoParc.toUpperCase() == 'PROSPECT' || tipoParc.toUpperCase() == 'CLIENTE'){
            this.checkIfCanEditOrEvolParc(nrParcNegocio).then(canEdit => {
                if(canEdit) {
                    General.widgetEdit(widget);
                    
                    widget.getField('NMOPERREAL').readOnly = true;
                    
                    this.setDescricaoDataSourceFilter(widget);
                    this.setDescricaoReadOnly(widget, true);
                    this.configureBlockedFieldsToEdit(widget, true);
                } else {
                    this.showMessageCantEditParc();
                }
            });
        } else {
            General.widgetEdit(widget);
            
            widget.getField('NMOPERREAL').readOnly = true;
            
            this.setDescricaoDataSourceFilter(widget);
            this.setDescricaoReadOnly(widget, true);
            this.configureBlockedFieldsToEdit(widget, true);
        }
    };
    
     this.cancelEditTask = function(widget) {
        widget.getField('NMOPERREAL').readOnly = false;
        General.widgetCancelForm(widget);
    };
    
    /**
     * Configura o estado das fields bloqueadas para
     * edição.
     * 
     * @param {object} widget widget de agenda de tarefas.
     * 
     * @param {boolean} isBlocked define se a field será
     * bloqueada ou não.
     */
    this.configureBlockedFieldsToEdit = function(widget, isBlocked) {

        var blockedFieldsToEdit = [
            widget.getField('NMPARCNEGOCIO')
        ];

        blockedFieldsToEdit.forEach(function(field) {
            field.readOnly = isBlocked;
        });

    };

    self.evolucaoNewRow = function(widget) {
        var mainWid = widget.parent.parent;
        var nrParcNegocio = mainWid.currentRow.NRPARCNEGOCIO;
        var tipoParc = mainWid.currentRow.TIPOPARCPRINC;
        
        if(tipoParc.toUpperCase() == 'PROSPECT' || tipoParc.toUpperCase() == 'CLIENTE'){
            this.checkIfCanEditOrEvolParc(nrParcNegocio).then(canEdit => {
                if(canEdit) {
                    if (mainWid.currentRow.NRSEQCONTATO || mainWid.currentRow.NRCONTATO) {
                        var loggedOperatorInfos = CRM_Utilities.getLoggedOperatorInfos();
                        
                        widget.getField('NMRESULTEVOL').readOnly = false;
                        
                        General.widgetNewRow(widget);
                        
                        self.defaultEditAuditRow(widget);
                        setLocalVar('PARCEIRO', mainWid.currentRow.NRPARCNEGOCIO);
                        
                        widget.currentRow.DTHREVOLCONT = (widget.currentRow.DTHREVOLCONT) ? widget.currentRow.DTHREVOLCONT : moment(new Date()).format('DD/MM/YYYY HH:mm');
                        widget.currentRow.NMOPERADOR = loggedOperatorInfos.NMOPERADOR;
                        widget.currentRow.CDOPEREVOL = loggedOperatorInfos.CDOPERADOR;
                        widget.currentRow.NMOPERADORREAL = loggedOperatorInfos.NMOPERADOR;
                        widget.currentRow.NRCONTATO = mainWid.currentRow.NRCONTATO;
                        widget.currentRow.NRSEQCONTATO = mainWid.currentRow.NRSEQCONTATO;
                        widget.currentRow.IDTPEVOLCONT = 'P';
                        widget.currentRow.IDSENEVOCONT = 'S';
                        widget.currentRow.IDANEXOEVOLCONT = 'N';
                        widget.currentRow.CDFILIAL = "";
                        widget.currentRow.IDGERAFATURA = 'NAO';
                        widget.currentRow.NRCONCORRENTE = "";
                        widget.currentRow.NMSEQFASENEGO = mainWid.currentRow.NMSEQFASENEGO;
                        
                        ABEvolucaoController.setEvolDateChangePermission(widget);
                        
                        this.setOpportunityGroupVisibilityBySelectedTask(widget);
                        this.getOpportNegotiationPhase(widget);
                        this.getOpportTermometro(widget);
                        this.setOportClosingDataGroupVisibility(widget);
                    } else {
                        ScreenService.showMessage(Messages.ERROR_EVOLUCAO_SEM_CONTATO);
                    }
                } else {
                    this.showMessageCantEditParc();
                }
            });
        } else {
            if (mainWid.currentRow.NRSEQCONTATO || mainWid.currentRow.NRCONTATO) {
                var loggedOperatorInfos = CRM_Utilities.getLoggedOperatorInfos();
                
                widget.getField('NMRESULTEVOL').readOnly = false;
                
                General.widgetNewRow(widget);
                
                self.defaultEditAuditRow(widget);
                setLocalVar('PARCEIRO', mainWid.currentRow.NRPARCNEGOCIO);
                
                widget.currentRow.DTHREVOLCONT = (widget.currentRow.DTHREVOLCONT) ? widget.currentRow.DTHREVOLCONT : moment(new Date()).format('DD/MM/YYYY HH:mm');
                widget.currentRow.NMOPERADOR = loggedOperatorInfos.NMOPERADOR;
                widget.currentRow.CDOPEREVOL = loggedOperatorInfos.CDOPERADOR;
                widget.currentRow.NMOPERADORREAL = loggedOperatorInfos.NMOPERADOR;
                widget.currentRow.NRCONTATO = mainWid.currentRow.NRCONTATO;
                widget.currentRow.NRSEQCONTATO = mainWid.currentRow.NRSEQCONTATO;
                widget.currentRow.IDTPEVOLCONT = 'P';
                widget.currentRow.IDSENEVOCONT = 'S';
                widget.currentRow.IDANEXOEVOLCONT = 'N';
                widget.currentRow.CDFILIAL = "";
                widget.currentRow.IDGERAFATURA = 'NAO';
                widget.currentRow.NRCONCORRENTE = "";
                widget.currentRow.NMSEQFASENEGO = mainWid.currentRow.NMSEQFASENEGO;
                
                ABEvolucaoController.setEvolDateChangePermission(widget);
                
                this.setOpportunityGroupVisibilityBySelectedTask(widget);
                this.getOpportNegotiationPhase(widget);
                this.getOpportTermometro(widget);
                this.setOportClosingDataGroupVisibility(widget);
            } else {
                ScreenService.showMessage(Messages.ERROR_EVOLUCAO_SEM_CONTATO);
            }
        }

        
    };

    self.defaultEditAuditRow = function(widget) {

        var loggedOperatorInfos = CRM_Utilities.getLoggedOperatorInfos();

        if (widget.currentRow.__is_new) {
            widget.currentRow.NRORG = loggedOperatorInfos.NRORG;
            widget.currentRow.NRORGINCLUSAO = loggedOperatorInfos.NRORG;
            widget.currentRow.CDOPERINCLUSAO = loggedOperatorInfos.CDOPERADOR;
            widget.currentRow.DTINCLUSAO = moment(new Date()).format('DD/MM/YYYY HH:mm');
        }
        else {
            widget.currentRow.NRORGULTATU = loggedOperatorInfos.NRORG;
            widget.currentRow.CDOPERULTATU = loggedOperatorInfos.CDOPERADOR;
            widget.currentRow.DTULTATU = moment(new Date()).format('DD/MM/YYYY HH:mm');
        }
    };

    self.checkRequirements = function(widget) {
        if (!widget.isValid()) {
            ScreenService.showMessage('Preencha todos os campos marcados com asterisco!');
            return false;
        }

        return true;
    };

    self.abrirPopupDeTransferencia = function(widget) {
        var rows = widget.getCheckedRows();
        var tasksIsValid = this.validateTasksByStatus(rows);
        if(tasksIsValid) {
            tasksIsValid = this.validateTasksByAssistant(rows);
        }
        
        
        if (rows && rows.length !== 0) {
            if (tasksIsValid) {
                widget.widgets[1].isVisible = true;
                ScreenService.openPopup(widget.widgets[1]);
            } else {
                ScreenService.showMessage("As tarefas selecionadas estão em algum dos status abaixo e a ação foi bloqueada.<br><br><li>As tarefas estão concluídas.<br><li>Os Parceiros relacionados das tarefas não pertencem à sua equipe de operadores.");
            }
        } else {
            ScreenService.showMessage(Messages.SELECIONAR_TAREFA_TRANSFERENCIA);
        }
    };

    this.validateTasksByStatus = function(tasks) {
        var isValid = true;
        
        tasks.forEach(function(task, count) {
            if (task.STATUS === "Concluída") {
                isValid = false;
            }
        });
        return isValid;
    };
    
    self.fecharPopupDeTransferencia = function(widget) {
        widget.isVisible = false;
        ScreenService.closePopup();
    };
    
    this.validateTasksByAssistant = function(tasks) {
        var isValid = true;
        
        tasks.forEach(function(task, count) {
            this.checkIfCanEditOrEvolParc(task.NRPARCNEGOCIO).then(canEdit => {
                if(canEdit) {
                    if(isValid) {
                        isValid = true;
                    }
                } else {
                    this.showMessageCantEditParc();
                    isValid = false;
                }
            });
        }.bind(this));
        return isValid;
    };

    self.fecharPopupDeTransferencia = function(widget) {
        widget.isVisible = false;
        ScreenService.closePopup();
    };

    self.transferirTarefa = function(widget) {
        var mainWid = widget.parent.parent;
        if(!widget.isValid()) return;
        
        var rows = mainWid.getCheckedRows();
        restEngine.post('/transferirTarefa', {
                'requestType': 'Row',
                'row': {
                    "ROW": rows,
                    "OPERADOR": widget.currentRow.CDOPERREAL,
                }
            },
            function(response) {
                widget.getField('NMOPERREAL').value("");
                ScreenService.showMessage('Tarefa(s) transferida(s) com sucesso.');
                ScreenService.closePopup();
                mainWid.unSelectAll();
                mainWid.reload();
            }, undefined,
            function(response) {
                ScreenService.showMessage(response);
            });
    };

    self.concluirTarefa = function(widget) {
        widget.currentRow.DTREALFILACONTA = moment(new Date()).format('YYYY/MM/DD HH:mm');
        restEngine.post('\/concluirTarefa', {
                'requestType': 'Row',
                'row': widget.currentRow
            },
            undefined, undefined, undefined).then(function(response) {
            ScreenService.showMessage('Tarefa concluída com sucesso.');
            ScreenService.closeSwipe();
            widget.list();
            widget.reload();
        });
    }; 

    self.podeModificarAgenda = function(widget) {
        widget.getAction('EDIT').isVisible = (widget.currentRow.DTREALFILACONTA === null);
        widget.widgets[0].getAction('ADD').isVisible = (widget.currentRow.DTREALFILACONTA === null);
        widget.getAction('CONCLUIR').isVisible = (widget.currentRow.DTREALFILACONTA === null);
    };

    self.saveTask = function(widget) {
        var nrParcNegocio = widget.currentRow.NRPARCNEGOCIO;
        var tipoParc = widget.currentRow.TIPOPARCPRINC;
        var currentRow = widget.currentRow;
        currentRow.NRORG = getLocalVar('CRM_NRORGTRAB');
        currentRow.CRM_NRORGTRAB = getLocalVar('CRM_NRORGTRABALHO');
        
        if(tipoParc.toUpperCase() == 'PROSPECT' || tipoParc.toUpperCase() == 'CLIENTE'){
            this.checkIfCanEditOrEvolParc(nrParcNegocio).then((canEdit) => {
                if(canEdit) {
                    if(currentRow.__is_new) {
                        General.callRestEngine("product#/verifyGroupRel", "DataSet", [currentRow]).then((response) => {
                            if(response.dataset && response.dataset.error) {
                                ScreenService.showMessage(response.dataset.error, 'ERROR');
                            }
                            if(response.dataset && response.dataset.GROUPREL[0] == false) {
                                if (self.checkRequirements(widget)) {
                                    var loggedOperatorInfos = CRM_Utilities.getLoggedOperatorInfos();
                                    self.defaultEditAuditRow(widget);
                                    widget.currentRow.CDFILIAL = "";
                                    widget.currentRow.CRM_NRORGTRAB = getLocalVar('CRM_NRORGTRABALHO');
                                    widget.currentRow.OPERADORDOLOGADO = loggedOperatorInfos.NMOPERADOR;
                                    widget.currentRow.NRSEQCLASSIFICATAREFA = (widget.currentRow.NRSEQCLASSIFICATAREFA) ? widget.currentRow.NRSEQCLASSIFICATAREFA : null;
                                
                                    return General.widgetSave(widget).then(function(response) {
                                        if (response.dataset.DADOS) {
                                            widget.currentRow.NRSEQFILACONTA = response.dataset.DADOS.NRSEQFILACONTA;
                                        }
                                        if (widget.currentRow.CDOPERINCLUSAO != widget.currentRow.CDOPERREAL && !Util.isEmptyOrBlank(widget.currentRow.DSEMAILOPER)) {
                                            ScreenService.confirmMessage('Deseja enviar um e-mail para o operador responsável da tarefa?', 'QUESTION', function(yes) {
                                                var params = {
                                                    "requestType": "Row",
                                                    "row": widget.currentRow
                                                };
                                                    
                                                restEngine.post('/enviaEmailTarefa', params).then(() => {
                                                    ScreenService.showMessage('E-mail enviado com sucesso!');
                                                }).catch(function(error) {
                                                    if(error.data.error) {
                                                        ScreenService.showMessage('O e-mail não pode ser enviado pois as configurações de SMTP estão desconfiguradas ou erradas!', 'ERROR');
                                                    } else {
                                                        ScreenService.showMessage(error.data.error);
                                                    }
                                                });
                                            }.bind(this));
                                        }
                                        this.setEvolutionWidgetfilter(widget);
                                        widget.getField('NMOPERREAL').readOnly = false;
                                        widget.reload();
                                    }.bind(this));
                                    this.setDescricaoDataSourceFilter(widget);
                                    this.setDescricaoReadOnly(widget, true);
                                }
                            } else {
                                ScreenService.showMessage('Operação Bloqueada! O parceiro de negócio está relacionado ao parceiro:<br>' + response.dataset.GROUPREL[0]['NRINSCRICAOPARC'] + ' - ' + response.dataset.GROUPREL[0]['NMPRINCIPALPARC'] + '!');
                            }
                        });
                    } else {
                        if (self.checkRequirements(widget)) {
                            var loggedOperatorInfos = CRM_Utilities.getLoggedOperatorInfos();
                            self.defaultEditAuditRow(widget);
                            widget.currentRow.CDFILIAL = "";
                            widget.currentRow.CRM_NRORGTRAB = getLocalVar('CRM_NRORGTRABALHO');
                            widget.currentRow.OPERADORDOLOGADO = loggedOperatorInfos.NMOPERADOR;
                            widget.currentRow.NRSEQCLASSIFICATAREFA = (widget.currentRow.NRSEQCLASSIFICATAREFA) ? widget.currentRow.NRSEQCLASSIFICATAREFA : null;
                        
                            return General.widgetSave(widget).then(function(response) {
                                if (response.dataset.DADOS) {
                                    widget.currentRow.NRSEQFILACONTA = response.dataset.DADOS.NRSEQFILACONTA;
                                }
                                if (widget.currentRow.CDOPERINCLUSAO != widget.currentRow.CDOPERREAL && !Util.isEmptyOrBlank(widget.currentRow.DSEMAILOPER)) {
                                    ScreenService.confirmMessage('Deseja enviar um e-mail para o operador responsável da tarefa?', 'QUESTION', function(yes) {
                                        var params = {
                                            "requestType": "Row",
                                            "row": widget.currentRow
                                        };
                                            
                                        restEngine.post('/enviaEmailTarefa', params).then(() => {
                                            ScreenService.showMessage('E-mail enviado com sucesso!');
                                        }).catch(function(error) {
                                            if(error.data.error) {
                                                ScreenService.showMessage('O e-mail não pode ser enviado pois as configurações de SMTP estão desconfiguradas ou erradas!', 'ERROR');
                                            } else {
                                                ScreenService.showMessage(error.data.error);
                                            }
                                        });
                                    }.bind(this));
                                }
                                this.setEvolutionWidgetfilter(widget);
                                widget.getField('NMOPERREAL').readOnly = false;
                                widget.reload();
                            }.bind(this));
                            this.setDescricaoDataSourceFilter(widget);
                            this.setDescricaoReadOnly(widget, true);
                        }
                    }
                } else {
                    this.showMessageCantEditParc();
                }
            });
        } else {
            if(currentRow.__is_new) {
                General.callRestEngine("product#/verifyGroupRel", "DataSet", [currentRow]).then((response) => {
                    if(response.dataset && response.dataset.error) {
                        ScreenService.showMessage(response.dataset.error, 'ERROR');
                    }
                    if(response.dataset && response.dataset.GROUPREL[0] == false) {
                        if (self.checkRequirements(widget)) {
                            var loggedOperatorInfos = CRM_Utilities.getLoggedOperatorInfos();
                            self.defaultEditAuditRow(widget);
                            widget.currentRow.CDFILIAL = "";
                            widget.currentRow.CRM_NRORGTRAB = getLocalVar('CRM_NRORGTRABALHO');
                            widget.currentRow.OPERADORDOLOGADO = loggedOperatorInfos.NMOPERADOR;
                            widget.currentRow.NRSEQCLASSIFICATAREFA = (widget.currentRow.NRSEQCLASSIFICATAREFA) ? widget.currentRow.NRSEQCLASSIFICATAREFA : null;
                           
                            return General.widgetSave(widget).then(function(response) {
                                if (response.dataset.DADOS) {
                                    widget.currentRow.NRSEQFILACONTA = response.dataset.DADOS.NRSEQFILACONTA;
                                }
                                if (widget.currentRow.CDOPERINCLUSAO != widget.currentRow.CDOPERREAL && !Util.isEmptyOrBlank(widget.currentRow.DSEMAILOPER)) {
                                    ScreenService.confirmMessage('Deseja enviar um e-mail para o operador responsável da tarefa?', 'QUESTION', function(yes) {
                                        var params = {
                                            "requestType": "Row",
                                            "row": widget.currentRow
                                        };
                                            
                                        restEngine.post('/enviaEmailTarefa', params).then(() => {
                                            ScreenService.showMessage('E-mail enviado com sucesso!');
                                        }).catch(function(error) {
                                            if(error.data.error) {
                                                ScreenService.showMessage('O e-mail não pode ser enviado pois as configurações de SMTP estão desconfiguradas ou erradas!', 'ERROR');
                                            } else {
                                                ScreenService.showMessage(error.data.error);
                                            }
                                        });
                                    }.bind(this));
                                }
                                this.setEvolutionWidgetfilter(widget);
                                widget.getField('NMOPERREAL').readOnly = false;
                                widget.reload();
                            }.bind(this));
                            this.setDescricaoDataSourceFilter(widget);
                            this.setDescricaoReadOnly(widget, true);
                        }
                    } else {
                        ScreenService.showMessage('Operação Bloqueada! O parceiro de negócio está relacionado ao parceiro:<br>' + response.dataset.GROUPREL[0]['NRINSCRICAOPARC'] + ' - ' + response.dataset.GROUPREL[0]['NMPRINCIPALPARC'] + '!');
                    }
                });
            } else {
                if (self.checkRequirements(widget)) {
                    var loggedOperatorInfos = CRM_Utilities.getLoggedOperatorInfos();
                    self.defaultEditAuditRow(widget);
                    widget.currentRow.CDFILIAL = "";
                    widget.currentRow.CRM_NRORGTRAB = getLocalVar('CRM_NRORGTRABALHO');
                    widget.currentRow.OPERADORDOLOGADO = loggedOperatorInfos.NMOPERADOR;
                    widget.currentRow.NRSEQCLASSIFICATAREFA = (widget.currentRow.NRSEQCLASSIFICATAREFA) ? widget.currentRow.NRSEQCLASSIFICATAREFA : null;
                
                    return General.widgetSave(widget).then(function(response) {
                        if (response.dataset.DADOS) {
                            widget.currentRow.NRSEQFILACONTA = response.dataset.DADOS.NRSEQFILACONTA;
                        }
                        if (widget.currentRow.CDOPERINCLUSAO != widget.currentRow.CDOPERREAL && !Util.isEmptyOrBlank(widget.currentRow.DSEMAILOPER)) {
                            ScreenService.confirmMessage('Deseja enviar um e-mail para o operador responsável da tarefa?', 'QUESTION', function(yes) {
                                var params = {
                                    "requestType": "Row",
                                    "row": widget.currentRow
                                };
                                    
                                restEngine.post('/enviaEmailTarefa', params).then(() => {
                                    ScreenService.showMessage('E-mail enviado com sucesso!');
                                }).catch(function(error) {
                                    if(error.data.error) {
                                        ScreenService.showMessage('O e-mail não pode ser enviado pois as configurações de SMTP estão desconfiguradas ou erradas!', 'ERROR');
                                    } else {
                                        ScreenService.showMessage(error.data.error);
                                    }
                                });
                            }.bind(this));
                        }
                        this.setEvolutionWidgetfilter(widget);
                        widget.getField('NMOPERREAL').readOnly = false;
                        widget.reload();
                    }.bind(this));
                    this.setDescricaoDataSourceFilter(widget);
                    this.setDescricaoReadOnly(widget, true);
                }
            }
        }
        
    };

    self.saveEvolucao = function(widget) {
        var mainWid = widget.parent.parent;
        var nrParcNegocio = mainWid.currentRow.NRPARCNEGOCIO;
        var tipoParc = mainWid.currentRow.TIPOPARCPRINC;
        
        if(tipoParc.toUpperCase() == 'PROSPECT' || tipoParc.toUpperCase() == 'CLIENTE'){
            this.checkIfCanEditOrEvolParc(nrParcNegocio).then(canEdit => {
                if(canEdit) {
                    if (self.checkRequirements(widget)) {
                    self.defaultEditAuditRow(widget);
                    if (!widget.currentRow.NRRELACIONAPARC) {
                        widget.currentRow.NRRELACIONAPARC = null;
                    }
                    
                    widget.currentRow.CRM_NRORGTRAB = getLocalVar('CRM_NRORGTRABALHO');
                    widget.currentRow.NRSEQFILACONTA = angular.copy(mainWid.currentRow.NRSEQFILACONTA);
                    var parcnegocio = angular.copy(mainWid.currentRow.NRPARCNEGOCIO);
                    var campanha    = angular.copy(mainWid.currentRow.NRSEQCAMPANHA);
                    var isNew = widget.currentRow.__is_new;
        
                    return General.widgetSave(widget).then(function(response) {
                        if (response.dataset.DADOS) {
                            widget.currentRow.NRSEQEVOLCONT = response.dataset.DADOS.NRSEQEVOLCONT;
                        }
                        
                        this.checkMail(widget).then(function(){ 
                            this.setOpportunityNegotiationPhase(widget);
                            this.setTaskEndDate(widget);
                
                            if (widget.currentRow.IDGERPROXATIV == 'S' && isNew) {
                                widget.currentRow.NRPARCNEGOCIO = parcnegocio;
                                widget.currentRow.NRSEQCAMPANHA = campanha;
                                widget.currentRow.CDOPERREAL = templateManager.LOGGEDOPERATOR.CDOPERADOR;
                                widget.currentRow.DSEMAILOPER = widget.currentRow.DSEMAILOPER || "";
                
                                var params = {
                                    "requestType": "Row",
                                    "row": widget.currentRow
                                };
                
                                restEngine.post('/filacontato_agendatarefasprincipal/inserirTarefa', params).
                                then(function(response) {
                                    widget.reload();
                                }).catch(function(error) {
                                    ScreenService.showMessage(error.data.error);
                                });
                            }
                
                            if (response.dataset.DADOS && response.dataset.DADOS.NRSEQEVOLCONT) {
                                widget.currentRow.NRSEQEVOLCONT = response.dataset.DADOS.NRSEQEVOLCONT;
                                widget.currentRow.DTINCLUSAO = response.dataset.DADOS.DTINCLUSAO;
                            }
                            else if (response.dataset.DADOS && response.dataset.DADOS.DTULTATU) {
                                widget.currentRow.DTULTATU = response.dataset.DADOS.DTULTATU;
                            }
                
                            if (Boolean(widget.currentRow.DESCRESULEVOL)) {
                                this.closeOport(widget).then(function() {
                                    ScreenService.showMessage(Messages.OPORTUNIDADE_CONCLUIDA);
                                });
                            }
                            
                            widget.reload();
                        }.bind(this));
                    }.bind(this)).catch(function(error) {
                        if(error.indexOf('REQUIRE_INTERLOCUTOR')  !== -1)
                            ScreenService.showMessage("Operação bloqueada! <br><br> Favor informar o interlocutor.");
                        else
                            ScreenService.showMessage(error);
                    });
                }
                this.setDescricaoDataSourceFilter(widget);
                this.setDescricaoReadOnly(widget, true);
                } else {
                    this.showMessageCantEditParc();
                }
            });
        } else {
            if (self.checkRequirements(widget)) {
                self.defaultEditAuditRow(widget);
                if (!widget.currentRow.NRRELACIONAPARC) {
                    widget.currentRow.NRRELACIONAPARC = null;
                }
                
                widget.currentRow.CRM_NRORGTRAB = getLocalVar('CRM_NRORGTRABALHO');
                widget.currentRow.NRSEQFILACONTA = angular.copy(widget.parent.parent.currentRow.NRSEQFILACONTA);
                var parcnegocio = angular.copy(widget.parent.parent.currentRow.NRPARCNEGOCIO);
                var campanha    = angular.copy(widget.parent.parent.currentRow.NRSEQCAMPANHA);
                var isNew = widget.currentRow.__is_new;
    
                return General.widgetSave(widget).then(function(response) {
                    if (response.dataset.DADOS) {
                        widget.currentRow.NRSEQEVOLCONT = response.dataset.DADOS.NRSEQEVOLCONT;
                    }
                    
                    this.checkMail(widget).then(function(){ 
                        this.setOpportunityNegotiationPhase(widget);
                        this.setTaskEndDate(widget);
            
                        if (widget.currentRow.IDGERPROXATIV == 'S' && isNew) {
                            widget.currentRow.NRPARCNEGOCIO = parcnegocio;
                            widget.currentRow.NRSEQCAMPANHA = campanha;
                            widget.currentRow.CDOPERREAL = templateManager.LOGGEDOPERATOR.CDOPERADOR;
                            widget.currentRow.DSEMAILOPER = widget.currentRow.DSEMAILOPER || "";
            
                            var params = {
                                "requestType": "Row",
                                "row": widget.currentRow
                            };
            
                            restEngine.post('/filacontato_agendatarefasprincipal/inserirTarefa', params).
                            then(function(response) {
                                widget.reload();
                            }).catch(function(error) {
                                ScreenService.showMessage(error.data.error);
                            });
                        }
            
                        if (response.dataset.DADOS && response.dataset.DADOS.NRSEQEVOLCONT) {
                            widget.currentRow.NRSEQEVOLCONT = response.dataset.DADOS.NRSEQEVOLCONT;
                            widget.currentRow.DTINCLUSAO = response.dataset.DADOS.DTINCLUSAO;
                        }
                        else if (response.dataset.DADOS && response.dataset.DADOS.DTULTATU) {
                            widget.currentRow.DTULTATU = response.dataset.DADOS.DTULTATU;
                        }
            
                        if (Boolean(widget.currentRow.DESCRESULEVOL)) {
                            this.closeOport(widget).then(function() {
                                ScreenService.showMessage(Messages.OPORTUNIDADE_CONCLUIDA);
                            });
                        }
                        
                        widget.reload();
                    }.bind(this));
                }.bind(this)).catch(function(error) {
                    if(error.indexOf('REQUIRE_INTERLOCUTOR')  !== -1)
                        ScreenService.showMessage("Operação bloqueada! <br><br> Favor informar o interlocutor.");
                    else
                        ScreenService.showMessage(error);
                });
            }
            this.setDescricaoDataSourceFilter(widget);
            this.setDescricaoReadOnly(widget, true);
        }
    };
    
    this.checkMail = function(widget){
        var promise = ZHPromise.defer();
        if(!Util.isEmptyOrBlank(widget.currentRow.NRSEQINTERLOCUTOR) && widget.currentRow.IDENVIAEMAIL === 'S'){
                    ScreenService.confirmMessage('Deseja enviar um email para '+widget.currentRow.NMINTERLOCUTOR+'?', 'QUESTION',
            function(yes){
                evolutionTabController.openWidgetSendMail(widget).then(function(){
                    promise.resolve();
                });
            }, function(no) {
                promise.resolve();
            });
        }else{
            promise.resolve();
        }
        return promise.promise;
    };

    /**
     * Define se o fieldgroup para fechar uma oportunidade
     * será exibido na widget.
     * 
     * @param {object} widget widget de evolução da tela
     * de agenda de tarefas.
     */
    this.setOportClosingDataGroupVisibility = function(widget) {

        var mainWidgetCurrentRow = widget.parent.parent.currentRow;
        var fgClosingData = CRM_Utilities.getObjectPositionInArrayByName(widget.fieldGroups, "FG_DADOS_FECHAMENTO");
        var currentRow = widget.currentRow;

        if (mainWidgetCurrentRow.TIPO === "OPORTUNIDADE" && Boolean(widget.COMPLETETASK)) {

            widget.fieldGroups[fgClosingData].isVisible = true;
            currentRow.DTREALFECHA = CRM_Utilities.getDataHoraAtual();

            this.setEvolutionRelatedValidadtionsByNegotiationPhase(widget);

        }
        else {
            widget.fieldGroups[fgClosingData].isVisible = false;
            this.returnOpportRelatedFieldsDefaulValidations(widget);
        }


    };

    /**
     * Fecha uma oportunidade ligada a uma tarefa.
     * 
     * @param {object} widget widget de evolução da tela
     * de agenda de tarefas.
     */
    this.closeOport = function(widget) {

        var currentRow = widget.currentRow;
        currentRow.NRSEQOPORT = widget.NRSEQOPORT;

        var params = {
            "requestType": "Row",
            "row": currentRow
        };

        this.setOpportunityNegotiationPhase(widget);

        return restEngine.post('/fecharOportunidade', params).then(function() {
            ScreenService.showMessage(Messages.OPORTUNIDADE_CONCLUIDA);
        }).catch(function(error) {
            ScreenService.showMessage(Messages.CATCH_EXCEPTION_ERROR(error.data.error));
        });

    };

    /**
     * Defini a fase de negociação da oportunidade concluída
     * de acordo com a fase selecionada pelo usuário.
     * 
     * @param {object} widget widget de evolução.
     */
    this.setOpportunityNegotiationPhase = function(widget) {

        var currentRow = widget.currentRow;

        if ((Boolean(currentRow.NRSEQFASENEGO) || Boolean(currentRow.NRTERMOPORTUNI)) && Boolean(widget.COMPLETETASK)) {

            var params = {
                "requestType": "Row",
                "row": this.setValuesToChangeOpport(widget)
            };

            return restEngine.post("product#/evolcont_crm_oportuni/atualizarOportunidade", params).then(function() {
                this.refreshEvolWidgetAndTaskWidgetToGetNewRelatedPhase(widget);
            }.bind(this)).catch(function(error) {
                console.log(error);
                ScreenService.showMessage(Messages.CATCH_EXCEPTION_ERROR(error.data.error));
            });

        }

    };

    /**
     * Define os valores a ser atualizados da oportunidade
     * em caso.
     * 
     * @param {object} widget widget de evoluções('evolucao').
     * 
     * @return {object} parâmetros para atualziar a oportunidade.
     */
    this.setValuesToChangeOpport = function(widget) {

        var currentRow = widget.currentRow;
        var params = {};

        params.NRSEQOPORT = widget.NRSEQOPORT;

        if (currentRow.NRSEQFASENEGO) {
            params.NRSEQFASENEGO = currentRow.NRSEQFASENEGO;
        }

        if (currentRow.VRPREVOPORT) {
            params.VRPREVOPORT = CRM_Utilities.removeValueCurrencyMask(currentRow.VRPREVOPORT);
        }

        if (currentRow.VROPORT) {
            params.VROPORT = CRM_Utilities.removeValueCurrencyMask(currentRow.VROPORT);
        }

        if (currentRow.NRPARCRESP) {
            params.NRPARCRESP = currentRow.NRPARCRESP;
        }

        if (currentRow.NRTERMOPORTUNI) {
            params.NRTERMOPORTUNI = currentRow.NRTERMOPORTUNI;
        }

        return params;

    };

    /**
     * Atualiza a widget de evolução e a widget de tarefas
     * para obter a nova fase de negociação relacionada.
     * 
     * @param {object} widget widget de evolução
     * ("evolucao").
     */
    this.refreshEvolWidgetAndTaskWidgetToGetNewRelatedPhase = function(widget) {

        widget.parent.parent.reload();
        widget.reload();

    };
    
    this.setDescricaoReadOnly = function(widget, keepValue){
        var parcnegocio = widget.currentRow.NRPARCNEGOCIO;
        var tipo = widget.getField('TIPO');
        var descricao = widget.getField('DESCRICAO');
        var interlocutor = widget.getField('NMINTERLOCUTOR');
        var telefone = widget.getField('DSTELEFONETAREFA');
        var email = widget.getField('DSEMAILTAREFA');
        
        if (!Util.isEmptyOrBlank(parcnegocio)) {
            tipo.readOnly = false;
            descricao.readOnly = false;
            interlocutor.readOnly = false;
            
            if(!keepValue){
                tipo.clearValue();
                descricao.clearValue();
                interlocutor.clearValue();
                telefone.clearValue();
                email.clearValue();
            }
        }
        else {
            tipo.readOnly = true;
            descricao.readOnly = true;
            interlocutor.readOnly = true;
            tipo.clearValue();
            descricao.clearValue();
            interlocutor.clearValue();
            telefone.clearValue();
            email.clearValue();
        }
    }

    self.setDescricaoDataSourceFilter = function(widget) {
        var descricao = widget.getField('DESCRICAO');

        descricao.dataSourceFilter[0].value = widget.currentRow.NRPARCNEGOCIO;
        descricao.dataSourceFilter[1].value = widget.currentRow.TIPO;
        
        if(widget.getField('TIPO').value() == 'OPORTUNIDADE') {
            descricao.dataSourceFilter.find(x => x.name == 'CRM_NRORGTRAB').value = getLocalVar('CRM_NRORGTRABALHO');
        } else {
            descricao.dataSourceFilter.find(x => x.name == 'CRM_NRORGTRAB').value = "";
        }
    };

    self.setComunicaDataSourceFilter = function(widget) {
        var comunica = widget.getField('CDCOMUNICAPARC');
        comunica.dataSourceFilter[1].value = widget.currentRow.NRPARCNEGOCIO;
    };

    self.initTabGeneric = function(widget, field) {
        if (widget.parent.currentRow[field]) {
            widget.dataSourceFilter[0].value = widget.parent.currentRow[field];
        }

        widget.reload();
    };

    self.activateField = function(widget, field, decisiveField) {
        field = widget.getField(field);
        decisiveField = widget.currentRow[decisiveField];

        if ((decisiveField === null) || (decisiveField === '') || (decisiveField === undefined)) {
            field.clearValue();
            field.readOnly = true;
            field.validations = {};
        }
        else {
            field.readOnly = false;
            field.validations.required = {};
        }
    };

    self.activateFieldDescricao = function(widget, field, decisiveField, onChange = false) {
        if(widget){
            var descricao = widget.getField('DESCRICAO');
            if (!Util.isEmptyOrBlank(descricao)) {
                descricao.readOnly = false;
                var value = widget.getField('TIPO').value();
                if(onChange && value !== backupTipo) {
                    descricao.value(null);
                }
                switch (value) {
                    case 'PARCEIRO':
                        backupTipo = value;
                        descricao.label = 'Parceiro'; 
                        break;
                    case 'CHAMADO':
                        backupTipo = value;
                        descricao.label = 'Ticket';
                        break;
                    case 'OPORTUNIDADE':
                        backupTipo = value;
                        descricao.label = 'Oportunidade';
                        break;
                    default:
                        backupTipo = value;
                        descricao.label = 'Código';
                        break;
                }
            } else {
                descricao.readOnly = true;
                descricao.label = 'Código';
                widget.currentRow.NRSEQCONTATO = null;
                widget.currentRow.NRCONTATO = null;
                widget.currentRow.DESCRICAO = "";
            }
            self.activateField(widget, field, decisiveField);
        }

    };

    /**
     * Função para definir o filtro dos campos
     * de motivo de contato e resultado, na widget
     * de evolução.
     * 
     * @param {object} widget widget de evolução.
     */
    this.setEvolutionResultFilterAndContactReasonFilter = function(widget) {

        var ContactReasonField = widget.getField("NMMOTIEVOCON");
        var ResultField = widget.getField("NMRESULTEVOL");
        
        this.setOperatorCodeFilterValueAndOrganizationNumberFilterValue(ContactReasonField);
        this.setOperatorCodeFilterValueAndOrganizationNumberFilterValue(ResultField);
    };
    
    this.updateSeqfilaFilter = function (widget) {
        widget.dataSourceFilter[2].value = widget.parent.parent.currentRow.NRSEQFILACONTA;
        //widget.reload();
    }

    /**
     * Função para setar valor dos filtros de
     * número de organização e código de operador
     * da field recebida como parâmetro, e logo
     * em seguida, recarrega a field.
     * 
     * @param {object} field field que receberá
     * o valor dos filtros
     */
    this.setOperatorCodeFilterValueAndOrganizationNumberFilterValue = function(field) {

        var loggedOperatorInfos = CRM_Utilities.getLoggedOperatorInfos();

        var fieldFilter = field.dataSourceFilter;
        var nrorgFilterIndex = CRM_Utilities.getFilterPosition(fieldFilter, "P_NRORG");
        var cdoperadorFilterIndex = CRM_Utilities.getFilterPosition(fieldFilter, "P_CDOPERADOR");

        fieldFilter[nrorgFilterIndex].value = loggedOperatorInfos.NRORG;
        fieldFilter[cdoperadorFilterIndex].value = loggedOperatorInfos.CDOPERADOR;

        field.reload();

    };

    /**
     * Função para abrir a widget de seleção
     * de arquivos.
     */
    this.openAnnexSwipe = function() {

        var fileUploadWidget = templateManager.container.getWidget('WDGT_SELECAO_ARQUIVOS');

        fileUploadWidget.isVisible = true;
        ScreenService.openSwipe(fileUploadWidget);

    };

    /**
     * Função para salvar os anexos selecionados
     * ao caso em questão.
     * 
     * @param {object} widget widget onde é
     * feito a seleção dos anexos.
     */
    this.uploadEvolutionFiles = function(widget) {

        var files = widget.currentRow.DSCAMINHO;

        var rows = [];

        files.forEach(function(file, fileIndex) {

            rows.push(this.setValuesForFileUpload(widget, fileIndex));

        }.bind(this));

        General.callRestEngine("product#/crm_anexocontato/save", "DataSet", rows).then(function() {

            this.closeAnnexSwipe(widget);
            widget.parent.parent.reload();

        }.bind(this));
    };

    /**
     * Função para retornar uma row configurada
     * com as informações do anexo referente
     * ao ID, recebido como parâmetro, no array
     * de anexos na currentRow.
     * 
     * @param {object} widget widget onde foi selecionado
     * os anexos.Array
     * 
     * @param {int} fileIndex index do anexo no array de 
     * anexos presente na currentRow.
     * 
     * @return {object} currentRow row configurada com as informações
     * do anexo referente ao ID recebido.
     */
    this.setValuesForFileUpload = function(widget, fileIndex) {

        var currentRow = angular.copy(widget.currentRow);
        var evolutionWidget = widget.parent.parent;
        var loggedOperatorInfos = CRM_Utilities.getLoggedOperatorInfos();

        currentRow.NRSEQCONTATO = evolutionWidget.getParent().currentRow.NRSEQCONTATO;
        currentRow.NMARQUIVO = this.getFileNameWithoutExtension(currentRow.DSCAMINHO[fileIndex].name);
        currentRow.DSTIPO = this.getFileExtension(currentRow.DSCAMINHO[fileIndex].name);
        currentRow.VRTAMANHO = currentRow.DSCAMINHO[fileIndex].size;
        currentRow.IDATIVO = "S";
        currentRow.NRORG = loggedOperatorInfos.NRORG;
        currentRow.CDOPERADOR = loggedOperatorInfos.CDOPERADOR;
        currentRow.IDORIGEM = "EVOLUCAO";
        currentRow.NRORIGEM = evolutionWidget.getParent().currentRow.NRSEQEVOLCONT;

        return currentRow;

    };

    /**
     * Função para retornar a extenção de um arquivo
     * extraida do seu nome.
     * 
     * @param {string} fileName nome completo do arquivo.
     */
    this.getFileExtension = function(fileName) {

        return fileName.replace(/^(.*)\.(.*)$/, "$2");

    };

    /**
     * Função para retornar o nome do arquivo sem
     * sua extenção.
     * 
     * @param {string} fileName nome completo do arquivo.
     */
    this.getFileNameWithoutExtension = function(fileName) {

        return fileName.replace(/^(.*)\.(.*)$/, "$1");

    };

    /**
     * Função para fechar o swipe de upload de imagens.
     * 
     * @param {object} widget widget de upload de imagens.
     */
    this.closeAnnexSwipe = function(widget) {
        var mainWid = widget.parent.parent;
        ScreenService.closeSwipe().then(function() {

            widget.isVisible = false;
            mainWid.list();
            mainWid.activate();

        });
    };

    /**
     * Função para fazer o download de uma arquivo
     * salvo no servidor.
     * 
     * @param {object} widget widget que contém
     * as informações do arquivo a ser baixado 
     * em sua currentRow.
     */
    this.downloadFile = function(widget) {

        window.open(window.fileServerBaseUrl + widget.currentRow.DSCAMINHO);

    };

    /**
     * Função para setar o filtro da widget
     * de evolução.
     * 
     * @param {object} widget widget de evolução.
     */
    this.setEvolutionWidgetfilter = function(gridWidget) {

        var widget = templateManager.container.getWidget("evolucao");
        var mainWid = widget.parent.parent;
        var widgetFilter = widget.dataSourceFilter;
        var hasFilterContato = false;

        widgetFilter[0].value = mainWid.currentRow.NRPARCNEGOCIO;

        widgetFilter.forEach(function(filter) {
            if (filter.name === "NRSEQCONTATO")
                hasFilterContato = true;
        });

        if (gridWidget.currentRow.TIPO === 'CHAMADO') {
            if (hasFilterContato) {
                widgetFilter[2].value = mainWid.currentRow.NRSEQCONTATO;
            }
            else {
                var filterContato = {
                    name: "NRSEQCONTATO",
                    operator: "=",
                    value: mainWid.currentRow.NRSEQCONTATO
                };
                widgetFilter.push(filterContato);
                hasFilterContato = true;
            }
        }
        else {
            if (hasFilterContato) {
                for(var i=0; i<widgetFilter.length; i++) {
                    if(widgetFilter[i].name == "NRSEQCONTATO") {
                        widgetFilter.splice(i,1);
                        hasFilterContato = false;
                        break;
                    }
                }
            }
        }

    };

    /**
     * Função para possibilitar o cadastro de
     * uma evolução referente a tarefa em caso,
     * indicando a conclusão da tarefa.
     * 
     * @param {object} widget widget ativa, no modo
     * view, referente a tarefa em caso.
     */
    this.completeTask = function(widget) {
        var nrParcNegocio = widget.currentRow.NRPARCNEGOCIO;
        var tipoParc = widget.currentRow.TIPOPARCPRINC;
        
        if(tipoParc.toUpperCase() == 'PROSPECT' || tipoParc.toUpperCase() == 'CLIENTE'){
            this.checkIfCanEditOrEvolParc(nrParcNegocio).then(canEdit => {
                if(canEdit) {
                    var evolutionWidget = templateManager.container.getWidget("evolucao");
                    
                    evolutionWidget.COMPLETETASK = true;
                    evolutionWidget.NRSEQFILACONTA = widget.currentRow.NRSEQFILACONTA;
                    evolutionWidget.NRORG = widget.currentRow.NRORG;
                    
                    if (Boolean(widget.currentRow.NRSEQOPORT)) {
                        evolutionWidget.NRSEQOPORT = widget.currentRow.NRSEQOPORT;
                    }
                    
                    ScreenService.closePopup();
                    
                    this.setOpportunityGroupVisibilityBySelectedTask(evolutionWidget);
                    this.setOportClosingDataGroupVisibility(evolutionWidget);
                    this.activateWidget(evolutionWidget).then(function() {
                        setTimeout(function() {
                            this.evolucaoNewRow(evolutionWidget);
                        }.bind(this), 500);
                    }.bind(this));
                } else {
                    this.showMessageCantEditParc();
                }
            });
        } else {
            var evolutionWidget = templateManager.container.getWidget("evolucao");
                    
            evolutionWidget.COMPLETETASK = true;
            evolutionWidget.NRSEQFILACONTA = widget.currentRow.NRSEQFILACONTA;
            evolutionWidget.NRORG = widget.currentRow.NRORG;
            
            if (Boolean(widget.currentRow.NRSEQOPORT)) {
                evolutionWidget.NRSEQOPORT = widget.currentRow.NRSEQOPORT;
            }
            
            ScreenService.closePopup();
            
            this.setOpportunityGroupVisibilityBySelectedTask(evolutionWidget);
            this.setOportClosingDataGroupVisibility(evolutionWidget);
            this.activateWidget(evolutionWidget).then(function() {
                setTimeout(function() {
                    this.evolucaoNewRow(evolutionWidget);
                }.bind(this), 500);
            }.bind(this));
        }
    };

    /**
     * Função para ativar uma widget
     * 
     * @param {object} widget widget que será
     * ativada.
     * 
     * @return {object} deferred 'promise' indicando
     * a conclusão da tarefa da função.
     */
    this.activateWidget = function(widget) {

        var deferred = ZHPromise.defer();

        widget.activate();
        deferred.resolve();

        return deferred;
    };

    /**
     * Função para pegar as informações da tarefa
     * na widget de evolução e setar a data de
     * conclusão da tarefa no registro da própria
     * tarefa.
     * 
     * @param {object} widget widget ativa que contém
     * as informações da tarefa que será concluida.
     */
    this.setTaskEndDate = function(widget) {

        if (widget.COMPLETETASK) {

            var taskWidget = templateManager.container.getWidget("Agenda");

            taskWidget.currentRow = {};

            taskWidget.currentRow.NRSEQFILACONTA = widget.NRSEQFILACONTA;
            taskWidget.currentRow.NRORG = widget.NRORG;

            this.concluirTarefa(taskWidget);
            this.deleteTaskInfosInEvolutionWidget(widget);

        }

    };

    /**
     * Função para deletar as informações da
     * tarefa a ser concluída da widget de evolução.
     * 
     * @param {object} widget widget de evolução.
     */
    this.deleteTaskInfosInEvolutionWidget = function(widget) {

        delete widget.COMPLETETASK;
        delete widget.NRSEQFILACONTA;
        delete widget.NRORG;

    };

    /**
     * Função para deletar uma tarefa, mas caso
     * ela tenha registros ligado a ela, a função permite
     * desativá-la.
     * 
     * @param {object} widget widget ativa, no modo
     * de visualização, com a tarefa em caso.
     */
    this.deleteTask = function(widget) {
        var nrParcNegocio = widget.currentRow.NRPARCNEGOCIO;
        var tipoParc = widget.currentRow.TIPOPARCPRINC;
        
        if(tipoParc.toUpperCase() == 'PROSPECT' || tipoParc.toUpperCase() == 'CLIENTE'){
            this.checkIfCanEditOrEvolParc(nrParcNegocio).then(canEdit => {
                if(canEdit) {
                    General.deleteCrud(widget).then(function() {
                    }).catch(function() {
                        ScreenService.confirmMessage(ScreenService.i18n(Messages.EXCLUSAO_TAREFA_VINC_EVOLUCAO), 'question',
                            function(success) {
                                this.deactivateTask(widget).then(function() {
                                    ScreenService.showMessage(Messages.TAREFA_INATIVADA);
                                    ScreenService.closeSwipe().then(function() {
                                        widget.reload();
                                    });
                                });
                            }.bind(this),
                            function(error) {
                            });
                    }.bind(this));
                } else {
                    this.showMessageCantEditParc();
                }
            });
        } else {
            General.deleteCrud(widget).then(function() {
            }).catch(function() {
                ScreenService.confirmMessage(ScreenService.i18n(Messages.EXCLUSAO_TAREFA_VINC_EVOLUCAO), 'question',
                    function(success) {
                        this.deactivateTask(widget).then(function() {
                            ScreenService.showMessage(Messages.TAREFA_INATIVADA);
                            ScreenService.closeSwipe().then(function() {
                                widget.reload();
                            });
                        });
                    }.bind(this),
                    function(error) {
                    });
            }.bind(this));
        }
    };
    
    /**
     * Função para deletar uma ou
     * mais tarefas.
     * 
     * @param {object} widget ativa, no modo
     * de visualização das tarefas filtradas
     * por operador
     */
    this.deleteMultipleTasks = function(widget) {
        var rows = widget.getCheckedRows();
        
        if(rows && rows.length !== 0) {
            var allParcsCantEditOrEvol = this.getAllParcsCantEditOrEvol(widget);
            
            if(allParcsCantEditOrEvol.length == 0){
                General.deleteCrudCheckedRows(widget).then(function() {
                    ScreenService.showMessage('Tarefa(s) excluída(s) com sucesso.');
                    ScreenService.closePopup();
                }).catch(function() {
                    ScreenService.confirmMessage(ScreenService.i18n(Messages.EXCLUSAO_TAREFA_VINC_EVOLUCAO), 'question',
                        function(success) {
                            ScreenService.closeSwipe().then(function() {
                                widget.reload();
                            });
                        }.bind(this),
                        function(error) {
                        });
                })
            }
            else {
                this.showMessageAllParcsCantEdit(allParcsCantEditOrEvol);
            }
        }
        else {
            ScreenService.showMessage(Messages.SELECIONAR_TAREFA_EXCLUSAO);
        }
        
    }
    
    /**
     * Função para recuperar todos os parceiros
     * que não possam ser editados ou evoluídos
     * pelo operador
     */
    this.getAllParcsCantEditOrEvol = function (widget) {
        var rows = widget.getCheckedRows();
        var parcsCantEditOrEvol = [];
        
        rows.forEach(row => {
            var nrParcNegocio = row.NRPARCNEGOCIO;
            var tipoParc = row.TIPOPARCPRINC;
            
            if(tipoParc.toUpperCase() == 'PROSPECT' || tipoParc.toUpperCase() == 'CLIENTE') {
                this.checkIfCanEditOrEvolParc(nrParcNegocio).then( canEdit => {
                    if(!canEdit){
                        parcsCantEditOrEvol.push(row.NMPARCNEGOCIO);
                    }
                });
            }
        });
        
        return parcsCantEditOrEvol;
    }
    
    this.showMessageAllParcsCantEdit = function(allParcsCantEdit) {
        var message = `Ação bloqueada!<br>
             Somente o operador responsável pelo(s) seguinte(s) prospect(s) e seus assistentes podem
             editá-lo(s)/evoluí-lo(s): `;
             
        allParcsCantEdit.forEach(parcCantEdit => message += `${parcCantEdit}, `);
        message = message.slice(0, message.length-2);
             
        ScreenService.showMessage(message);
    };

    /**
     * Função para desativar uma tarefa.
     * 
     * @param {object} widget widget com as 
     * informações da tarefa a ser desativada em sua
     * currentRow.
     */
    this.deactivateTask = function(widget) {

        var paramsRestEngine = {
            "requestType": "Row",
            "row": widget.currentRow
        };

        return restEngine.post('/deactivateTask', paramsRestEngine,
            function(success) {

            }, undefined,
            function(error) {

            }, undefined, undefined
        );

    };

    this.prepareFieldsNextTask = function(widget) {

        var nextTaskDate = widget.getField("DTPLANFILACONTA");
        var taskOperator = widget.getField("NMOPERADORREAL");
        var taskDescription = widget.getField("DSFILACONTATO");
        var taskClassification = widget.getField("DSCLASSIFICATAREFA");
        var taskPriority = widget.getField("NRPRIORFILACONT");

        nextTaskDate.readOnly = true;
        taskOperator.readOnly = true;
        taskDescription.readOnly = true;
        taskClassification.readOnly = true;
        taskPriority.readOnly = true;
        
        nextTaskDate.validations.required = false;
        taskOperator.validations.required = false;
        taskDescription.validations.required = false;
        taskPriority.validations.required = false;
    };


    this.changeOperatorFilter = function(args) {

        var widget = args.owner;
        var filterPopup = args.e.preference.FILTER_ROW;
        var cdoperador = filterPopup.CDOPERREAL;
        var filtros = widget.dataSourceFilter;
        var allOperators = true;

        //2 = Quantidade padrão de filtros, ou seja, se algo foi filtrado
        if (filtros.length !== 2) {
            filtros.forEach(function(filtro) {
                //Se filtrou operador
                if (filtro.name === "CDOPERREAL") {
                    allOperators = false;
                }
            });
        }
        else {
            //Se nada foi filtrado operador logado é o padrão
            var defaultOperator = {};
            defaultOperator.name = "CDOPERREAL";
            defaultOperator.operator = "IN";
            defaultOperator.value = [getLocalVar('CRM_CDOPERADOR')];
            defaultOperator.static = true;
            filtros.push(defaultOperator);
            allOperators = false;
        }
        //Se algo foi filtrado e operador não foi setado, todos é o padrão
        if (allOperators) {
            allOperators = {};
            allOperators.name = "CDOPERREAL";
            allOperators.operator = "IS_NOT_NULL";
            allOperators.static = true;
            filtros.push(allOperators);
        }

    };

    /**
     * Função para editar uma evolução.
     * 
     * @param {object} widget widget ativa, no
     * modo de visualização, com as informações
     * da evolução a ser editada.
     */
    this.editEvolution = function(widget) {
        var nrParcNegocio = widget.parent.parent.currentRow.NRPARCNEGOCIO;
        var tipoParc = widget.parent.parent.currentRow.TIPOPARCPRINC;
        
        if(tipoParc.toUpperCase() == 'PROSPECT' || tipoParc.toUpperCase() == 'CLIENTE'){
            this.checkIfCanEditOrEvolParc(nrParcNegocio).then(canEdit => {
                if(canEdit) {
                    this.blockfieldsNextTask(widget, 'fdgAgendarTarefa', true);
                    if (widget.name === 'evolucao') {
                        widget.getField('NMRESULTEVOL').readOnly = true;
                    }
                    General.widgetEdit(widget);
                    
                    ABEvolucaoController.setEvolDateChangePermission(widget);
                } else {
                    this.showMessageCantEditParc();
                }
            });
        } else {
            this.blockfieldsNextTask(widget, 'fdgAgendarTarefa', true);
            if (widget.name === 'evolucao') {
                widget.getField('NMRESULTEVOL').readOnly = true;
            }
            General.widgetEdit(widget);
            
            ABEvolucaoController.setEvolDateChangePermission(widget);
        }
        
    };

    this.widgetCancelForm = function(widget) {
        this.blockfieldsNextTask(widget, 'fdgAgendarTarefa', false);
        if (widget.name === 'evolucao')
            widget.getField('NMRESULTEVOL').readOnly = false;
        General.widgetCancelForm(widget);
        this.deleteTaskInfosInEvolutionWidget(widget);
    };

    this.blockfieldsNextTask = function(widget, name, block) {
        widget.fields.forEach(function(field) {
            if (field.fieldGroup === name) {
                field.readOnly = block;
            }
        });
    };

    /**
     * Define as regras da tela de agenda de tarefas
     * de acordo com a revenda do operador logado.
     * 
     * @param {object} widget widget principal da tela 
     * de agenda de tarefas ('Agenda').
     */
    this.setResaleRules = function(widget) {

        var loggedOperatorInfos = CRM_Utilities.getLoggedOperatorInfos();

        if (loggedOperatorInfos.IDTPOPERADOR === 'R' && Boolean(loggedOperatorInfos.NRREVENDA)) {

            var restrictObjects = [];

            restrictObjects.push(widget.getField("NMOPERREAL"));
            restrictObjects.push(widget.getField("CDOPERREAL"));
            restrictObjects.push(widget.getField("NMPARCNEGOCIO"));
            restrictObjects.push(widget.getField("NRPARCNEGOCIO"));

            var taskTransferWidget = templateManager.container.getWidget("TRANSFERIR");
            restrictObjects.push(taskTransferWidget.getField("NMOPERREAL"));

            var evolutionWidget = templateManager.container.getWidget("evolucao");
            restrictObjects.push(evolutionWidget.getField("NMOPERADORREAL"));

            CRM_Utilities.setResaleRulesInRestrictObjectsByLoggedOperatorResale(restrictObjects);

        }
        
        //widget.reload();
    };

    /**
     * Define a visibilidade do fieldgroup("FG_OPORTUNIDADE")
     * de acordo com a tarefa selecionada.
     * 
     * @param {object} widget widget de evolucao ("evolucao");
     */
    this.setOpportunityGroupVisibilityBySelectedTask = function(widget) {

        var parentWidgetCurrentRow = widget.parent.parent.currentRow;
        var phaseField = widget.getField('NMSEQFASENEGO');

        if (parentWidgetCurrentRow.TIPO === "OPORTUNIDADE" && Boolean(widget.COMPLETETASK)) {

            this.setOpportunityGroupVisibility(widget, true);
            this.setOpportFieldGroupDefaultValues(widget);

            phaseField.validations = {
                required: true
            };

        }
        else {

            this.setOpportunityGroupVisibility(widget, false);

            phaseField.validations = {};
            widget.currentRow[phaseField.name] = "";

        }

    };

    /**
     * Define os valores iniciais do grupo de campos relacionados
     * a oportunidade da tarefa, quando a mesmo for carregada.
     * 
     * @param {object} widget widget de evolução ("evolucao").
     */
    this.setOpportFieldGroupDefaultValues = function(widget) {

        var parentWidgetCurrentRow = widget.parent.parent.currentRow;
        var currentRow = widget.currentRow;

        currentRow.VRPREVOPORT = parentWidgetCurrentRow.VRPREVOPORT;

    };

    /**
     * Define a visibilidade do grupo de oportunidade.
     * 
     * @param {object} widget widget de evolucao ("evolucao").
     * 
     * @param {boolean} isVisible valor lógico definindo se o grupo
     * será visivel ou não.
     */
    this.setOpportunityGroupVisibility = function(widget, isVisible) {

        var opportFieldGroupIndex = CRM_Utilities.getObjectPositionInArrayByName(widget.fieldGroups, "FG_OPORTUNIDADE");
        var opportFieldGroup = widget.fieldGroups[opportFieldGroupIndex];

        opportFieldGroup.isVisible = isVisible;

    };

    /**
     * Busca a fase de negociação da oportunidade
     * relacionada a tarefa selecionada e seta na
     * currentRow da evolução.
     * 
     * @param {object} widget widget de evolução
     * ("evolucao").
     */
    this.getOpportNegotiationPhase = function(widget) {

        var parentWidgetCurrentRow = widget.parent.parent.currentRow;
        var currentRow = widget.currentRow;

        if (parentWidgetCurrentRow.TIPO === "OPORTUNIDADE") {

            widget.NRSEQOPORT = parentWidgetCurrentRow.NRSEQOPORT;
            currentRow.NRSEQFASENEGO = parentWidgetCurrentRow.NRSEQFASENEGO;
            currentRow.NMSEQFASENEGO = parentWidgetCurrentRow.NMSEQFASENEGO;
            currentRow.IDPERMITEFECHA = parentWidgetCurrentRow.IDPERMITEFECHA;

        }

    };

    /**
     * Busca o termometro da oportunidade
     * relacionada a tarefa selecionada e seta na
     * currentRow da evolução.
     * 
     * @param {object} widget widget de evolução
     * ("evolucao").
     */
    this.getOpportTermometro = function(widget) {

        var parentWidgetCurrentRow = widget.parent.parent.currentRow;
        var currentRow = widget.currentRow;

        if (parentWidgetCurrentRow.TIPO === "OPORTUNIDADE") {

            widget.NRSEQOPORT = parentWidgetCurrentRow.NRSEQOPORT;
            currentRow.NRTERMOPORTUNI = parentWidgetCurrentRow.NRTERMOPORTUNI;
            currentRow.NMTERMOPORTUNI = parentWidgetCurrentRow.NMTERMOPORTUNI;
            currentRow.IDPERMITEFECHA = parentWidgetCurrentRow.IDPERMITEFECHA;

        }

    };

    this.alteraMunicipioReadonly = function(widget) {
        widget = templateManager.container.getWidget('Agenda').__filterPopup;
        var estadoField = widget.getField("NMESTADO");
        var municipioField = widget.getField("NMMUNICIPIO");
        var currentRow = widget.currentRow;
        if (!estadoField.value()) {
            municipioField.readOnly = true;
            currentRow.CDMUNICIPIO = null;
            currentRow.NMMUNICIPIO = null;
            municipioField.dataSourceFilter[1].value = "";
        }
        else {
            municipioField.readOnly = false;
            municipioField.dataSourceFilter[1].value = widget.currentRow.SGESTADO;
        }
    };

    this.setFilterRelacionadoA = function(widget) {
        var descricaoField = widget.getField('DESCRICAO');
        var tipoField = widget.getField('TIPO');
        var interlocutorField = widget.getField('NMINTERLOCUTOR');

        if (!Util.isEmptyOrBlank(tipoField.value())) {
            descricaoField.dataSourceFilter.forEach(function(filter) {
                if (filter.name === "SEPARADOR")
                    filter.value = tipoField.value();
            });
            descricaoField.readOnly = false;
        }
        else {
            descricaoField.readOnly = true;
        }
    };

    /**
     * Configura as validações da widget de evolução referentes a 
     * fase de negociação.
     * 
     * @param {object} widget widget de evoluções('evolucao').
     */
    this.setEvolutionRelatedValidadtionsByNegotiationPhase = function(widget) {

        this.setOpportClosingValidationsByNegotiationPhase(widget);
        this.setOpportValueFieldValidationsByNegotiationPhase(widget);

    };

    /**
     * Define a validação padrão dos campos relacionados a oportunidade,
     * na widget de evolução('evolucao').
     * 
     * @param {object} widget widget de evolução('evolucao').
     */
    this.returnOpportRelatedFieldsDefaulValidations = function(widget) {

        var fields = [
            widget.getField('NMSEQFASENEGO'),
            widget.getField('VRPREVOPORT'),
            widget.getField('VROPORT'),
            widget.getField('DESCRESULEVOL'),
            widget.getField('NMPARCRESP')
        ];

        fields.forEach(function(field) {
            field.validations = {};
        });

    };

    /**
     * Define se a fase de negociação da oportunidade relacionada a tarefa
     * selecionada obriga o usuário a fechar a oportunidade.
     * 
     * @param {object} widget widget de evolução('evolucao').
     */
    this.setOpportClosingValidationsByNegotiationPhase = function(widget) {

        var opportValueField = widget.getField('VROPORT');
        var resultField = widget.getField('DESCRESULEVOL');

        var currentRow = widget.currentRow;

        if (currentRow.IDPERMITEFECHA === 'S') {
            opportValueField.validations = {
                required: true
            };
            resultField.validations = {
                required: true
            };
        }else {
            opportValueField.validations = {};
            resultField.validations = {};
        }

    };

    /**
     * Define a obrigatoriedade do campo
     * 'valor previsto da oportunidade' de acordo com a fase de
     * negociação em caso.
     * 
     * @param {object} widget widget de oportunidade.
     */
    this.setOpportValueFieldValidationsByNegotiationPhase = function(widget) {

        var currentRow = widget.currentRow;
        var valueOportField = widget.getField('VRPREVOPORT');

        if (currentRow.IDEXIGEVROPORT === 'S') {
            valueOportField.validations = {
                required: true
            };
        }
        else {
            valueOportField.validations = {};
        }

    };
    
    
    /**
     * Muda o campo de data no filtro, para filtrar pela data real,
     * e não pelo campo DATATAREFA, que é um char. Muda também o segundo
     * valor do between para o último minuto do dia selecionado.
    */
    this.buildDataFilter = function(widget){
        widget.dataSourceFilter.forEach(function(filter, CDOPERREAL){
            if(filter.name === 'DATATAREFA'){
                filter.name = 'DTPLANFILACONTA';
                filter.value[0] += ' 00:00';
                filter.value[1] += ' 23:59';
            }    
        });   
    };
    
    this.setMunicipioFilters = function(widget) {
        var municipioField = widget.getField('NMMUNICIPIO');
        
        var dsFilterPais = municipioField.dataSourceFilter.find(function(filter) {
            return filter.name == "CDPAIS";
        });
        
        if(dsFilterPais) {
            dsFilterPais.value = "0055";
        }
    };
    
    this.openFilter = async function(widget) {
        var filterRow = {};
        var loggedOper = templateManager.LOGGEDOPERATOR;
        var orgField = widget.getField('CRM_NRORGTRAB');
        var nmOrgField = widget.getField('NMORGTRAB');
        
        filterRow.CDOPERREAL = [loggedOper.CDOPERADOR];
        filterRow.NMOPERADOR = [loggedOper.NMOPERADOR];
        filterRow.NMORGTRAB = [getLocalVar('NMORGTRAB')];
        filterRow.CRM_NRORGTRAB = [getLocalVar('CRM_NRORGTRABALHO')];
        
        var filtro = [
            {
                "name": "P_NRORG",
                "operator": "=",
                "value": getLocalVar('CRM_NRORGTRAB')
            },
            {
                "name": "P_CDOPERADOR",
                "operator": "=",
                "value": loggedOper.CDOPERADOR
            }
        ];
        await General.callRestEngine("product#/getRelatedOrganizations", "FilterData", filtro).then((response) => {
            if(response.dataset && response.dataset.getRelatedOrganizations) {
                if(response.dataset.getRelatedOrganizations.length > 1) {
                    nmOrgField.isVisible = true;
                    orgField.isVisible = true;
                    nmOrgField.filterProperties.isVisible = true;
                } else {
                    nmOrgField.isVisible = false;
                    orgField.isVisible = false;
                    nmOrgField.filterProperties.isVisible = false;
                }
            } else {
                templateManager.project.userDataActions = [];
            }
        });
        
        
        
        CRM_Utilities.openFilterOnEnter(widget, filterRow, ['STATUS_PRINCIPAL', 'CDOPERREAL', 'NMOPERREAL', 'CRM_NRORGTRABALHO']);
    };

    this.setStatusTitle = function(row, element, status) {
        element.attr('title', status);
    };
    
    this.evolucaoRowOnEnter = function(widget) {
        var prospectController = CRM_Utilities.getController('ger45000_Prospect_Controller');
        
        prospectController.setEditEvolButtonAction(widget, this.editEvolButtonDefaultCode, 'EDITAR_EVOLUCAO');
    };
    
    this.setNextTaskVisibility = function(taskGroupName) {
        var widget = templateManager.container.getWidget('evolucao');
        
        // Pega o grupo de campos relacionado à próxima tarefa
        var taskGroup = widget.fieldGroups.find(x => x.name == taskGroupName);
        
        // Se o resultado selecionado estiver parametrizado para gerar tarefa,
        //o grupo ficará visível. Caso contrário, ficará invisível
        var geraProxTarefa = widget.currentRow.IDGERPROXATIV === 'S';
        
        var taskFields = widget.fields.filter(x => x.fieldGroup == taskGroupName);
        
        taskFields.forEach(function(field) {
            field.isVisible = geraProxTarefa;
        });
        
        taskGroup.isVisible = geraProxTarefa;
    };
    
    this.editEvolButtonDefaultCode = 
        `Crm_31000_Agenda_de_Tarefas_Controller.editEvolution(args.owner.widget);
         ger45000_Prospect_Controller.setNextTaskVisibility(args.owner.widget, 'fdgAgendarTarefa');`;
         
    this.setInterlocutorWidgetDefaultValues = function(widget){
        var wid = templateManager.container.getWidget('Agenda');
        
        wid.currentRow.NRPARCNEGOCIO;
        
        widget.currentRow.NRPARCNEGOCIO = wid.currentRow.NRPARCNEGOCIO;
    };
    
    this.removeCustomFilters = function() {
        var widget = templateManager.container.getActiveWidget();
        if(widget.customFilter) {
            widget.dataSourceFilter.forEach(function(filter, index, dataSourceFilter) {
                if (filter.name === "NRPARCNEGOCIO") {
                    dataSourceFilter[index].name = 'CDOPERREAL';
                    dataSourceFilter[index].value = [templateManager.LOGGEDOPERATOR.CDOPERADOR];
                }
            });
            var status = {
                name: "STATUS_PRINCIPAL",
                operator: "IN",
                value: ["ATRASADA", "HOJE", "FUTURA"]
            };
            widget.dataSourceFilter.push(status);
            delete widget.customFilter;
        }
    };
    
    this.returnToMainGrid = function() {
        var mainWid = templateManager.container.getWidget('Agenda');
        
        ScreenService.closeSwipe();
        mainWid.activate();
        mainWid.list();
    };
    
    this.verificaExistenciaContato = function() {
        var widget = templateManager.container.getWidget('Agenda');
        
        if(Util.isEmptyOrBlank(widget.currentRow.NRSEQCONTATO) && !widget.currentRow.__is_new) {
            var params = {
                'requestType':'Row',
                'row': {"NRPARCNEGOCIO": widget.currentRow.NRPARCNEGOCIO, "NRORG": widget.currentRow.NRORG}
            };
            restEngine.post('/selectProspectNrContato', params,
                function(success) {
                    widget.currentRow.NRSEQCONTATO = success.dataset.DADOS.NRSEQCONTATO;
                    widget.currentRow.NRCONTATO = success.dataset.DADOS.NRSEQCONTATO;
                });
        }
    };
    
    this.checkIfCanEditOrEvolParc = function(nrParcNegocio) {
        var restRow = {
            NRPARCNEGOCIO: nrParcNegocio,
            CRM_NRORGTRAB: getLocalVar('CRM_NRORGTRABALHO')
        };
        
        var params = {
            requestType: 'Row',
            row: restRow
        };
        
        return restEngine.post('/checkIfCanEditOrEvolParc', params).then(response => {
            return response.dataset.DADOS.CAN_EDIT;
        }).catch(() => {
            return false;
        });
    };
    
    this.showMessageCantEditParc = function() {
        var message = `Ação bloqueada!<br>
             Somente o operador responsável pelo prospect e seus assistentes podem
             editá-lo/evoluí-lo.`;
             
        ScreenService.showMessage(message);
    };
    
}

Configuration(function(ContextRegister) {
    ContextRegister.register('Crm_31000_Agenda_de_Tarefas_Controller', Crm_31000_Agenda_de_Tarefas_Controller);
});
