function MixController(ScreenService, templateManager, Utilities, wizardEngine, ZHPromise, Operador_Repository, General) {
	var self = this;

	self.paramsCRMInit = function() {
		var widget = templateManager.container.getActiveWidget();
		var data = widget.dataSource.data[0];

		widget.currentRow.CASOMENSAGEM = "O ''Modelo de Caso'' define um modelo padrão de informações para a abertura de um caso. Entre as informações definidas para o caso estão o ''Código Padrão do Caso'' (responsável por especificar um código padrão para a identificação dos casos) e a ''Situação de Abertura do Caso''. Também são definidos padrões para as evoluções dos casos, como: ''Tipo de Contato Padrão'', ''Motivo de Evolução Padrão'' e ''Descrição de Evolução Padrão''.";
		widget.currentRow.NOTIFICAMENSAGEM = "Serão enviadas notificações quando:";

		widget.view();

		if(!data) {
			widget.currentRow.__is_new = true;
			return;
		} else widget.currentRow.__is_new = false;

		widget.currentRow.NRSEQRELATIONE = data.NRSEQRELATIONE;
		widget.currentRow.DSDIRANEXOCONT = data.DSDIRANEXOCONT;
		widget.currentRow.IDOBRIGAINSCJUR = data.IDOBRIGAINSCJUR;
		widget.currentRow.IDCONTROLEACESSODADOSPERFIL = data.IDCONTROLEACESSODADOSPERFIL;
		widget.currentRow.IDOBRIGACPF = data.IDOBRIGACPF;
		widget.currentRow.IDCRIAOPORTLEAD = data.IDCRIAOPORTLEAD;
		widget.currentRow.IDOBRIGACOMUNICACAOCONVERSAO = data.IDOBRIGACOMUNICACAOCONVERSAO;
		widget.currentRow.NRSEQMODELOCASO = data.NRSEQMODELOCASO;
		widget.currentRow.IDUTILIZACONTRTEMPO = data.IDUTILIZACONTRTEMPO;
		widget.currentRow.HRUTILHORATENINI = data.HRUTILHORATENINI;
		widget.currentRow.HRUTILHORATENFIN = data.HRUTILHORATENFIN;
		widget.currentRow.QTTMPRETONATEN = data.QTTMPRETONATEN;
		widget.currentRow.DSURLPESQSATISFACAO = data.DSURLPESQSATISFACAO;
		widget.currentRow.IDNOTIFICAOPORTUNI = data.IDNOTIFICAOPORTUNI;
		widget.currentRow.IDNOTIFICATAREFA = data.IDNOTIFICATAREFA;
		widget.currentRow.IDNOTIFICACOMPR = data.IDNOTIFICACOMPR;
		widget.currentRow.IDNOTIFICAPARCNEG = data.IDNOTIFICAPARCNEG;
		widget.currentRow.IDNOTIFICACASO = data.IDNOTIFICACASO;
	};

	self.setDefaultValueOperador = function(field, parametro)
	{
        Operador_Repository.retornaOperadorLogado().then(function(operator)
        {
        	if(operator[0] === undefined || operator[0] === null)
            {
                ScreenService.showMessage("Erro ao realizar a operação.");
                return;
            }

					field.defaultValue = operator[0][parametro];
        },function(error)
        {
            ScreenService.showMessage("Erro ao realizar a operação.");
        });
	};

	self.iniciaFiltrosWidtop10casossemconc = function(widget)
    {
        Operador_Repository.retornaOperadorLogado().then(function(operator)
        {
        	if(operator[0] === undefined || operator[0] === null)
          {
              ScreenService.showMessage("Erro ao realizar a operação.");
              return;
          }

        	Utilities.insertFilter(widget, "P_NRORG", "=", operator[0].NRORG, 0);
        	Utilities.insertFilter(widget, "P_CDOPERADOR", "=", operator[0].CDOPERADOR, 1);
        },function(error)
        {
            ScreenService.showMessage("Erro ao realizar a operação.");
        });
    };
    
    self.save = function(widget){
    	General.widgetSave(widget).then(function(){
    		widget.reload();	
    	});
    };
    
    this.showWonLostField = function(widget){
    	if(widget.currentRow.IDRESULTOPORTUNI === 'SIM'){
    		widget.getField('IDGANHAPERDE').isVisible = true;
    		widget.getField('IDGANHAPERDE').validations = {required:true};
    		widget.getField('IDRESULTOPORTUNI').class = "8";
    	}else{
    		widget.getField('IDGANHAPERDE').isVisible = false;
    		widget.getField('IDGANHAPERDE').validations = {};
    		widget.getField('IDRESULTOPORTUNI').class = "12";
    	}
    }
}

Configuration(function(ContextRegister) {
    ContextRegister.register('MixController', MixController);
});